SystemOrganization addCategory: #'Alt-Browser'!
SystemOrganization addCategory: #'Alt-Browser-Commands'!
SystemOrganization addCategory: #'Alt-Browser-Standard-Commands'!
SystemOrganization addCategory: #'Alt-Browser-Refactory-Commands'!
SystemOrganization addCategory: #'Alt-Browser-Refactory-Commands-Replacement'!
SystemOrganization addCategory: #'Alt-Browser-Refactory-Definitions-Replacement'!
SystemOrganization addCategory: #'Alt-Browser-Standard-Definitions'!
SystemOrganization addCategory: #'Alt-Browser-Standard-Announcements'!
SystemOrganization addCategory: #'Alt-Browser-Announcements'!
SystemOrganization addCategory: #'Alt-Browser-Notifications'!
SystemOrganization addCategory: #'Alt-Browser-Utilities'!

MorphTreeModel subclass: #ABPackageList
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Alt-Browser'!

!ABPackageList commentStamp: '<historical>' prior: 0!
An ABPackageList is in charge of displaying a tree of Packages / Category / Classes / Protocols / Methods.

It's a non-Spec based attempt.

ABPackageList open!

!ABPackageList class methodsFor: 'as yet unclassified' stamp: 'ThierryGoubier 7/16/2012 00:42'!
defaultPackageCategoriesNames
	"As it says: categories for packages who don't use the - convention."
	
	^ #('Configuration' 'Nautilus' 'Text' 'Shout' 'Collections' 'Fuel' 'Morphic' 'Monticello' 'Tools' 'Compiler' 'Network' 'Compression' 'Balloon' 'Kernel' 'FreeType' 'SmaCC')! !

!ABPackageList class methodsFor: 'instance creation' stamp: 'ThierryGoubier 7/14/2012 11:10'!
open
	^ self new open! !

!ABPackageList class methodsFor: 'as yet unclassified' stamp: 'ThierryGoubier 7/17/2012 12:52'!
rootItems
	"This is where I should rework the organisation. Use broad classes to reduce the number of top-level items. To be improved. Does not catch classes which have no "

	| l o |
	l := MCWorkingCopy allManagers asOrderedCollection.
	o := OrderedCollection new.
	self defaultPackageCategoriesNames
		do: [ :w | 
			| i |
			i := w -> OrderedCollection new.
			(l select: [ :e | e packageName size >= w size and: [ (e packageName copyFrom: 1 to: w size) = w ] ])
				do: [ :e | 
					l remove: e.
					i value add: e ].
			o add: i ].
	[ l notEmpty ]
		whileTrue: [ 
			| p w i |
			p := l first.
			w := p packageName copyUpTo: $-.
			i := w -> (OrderedCollection with: p).
			o add: i.
			l remove: p.
			(l select: [ :e | (e packageName copyUpTo: $-) = w ])
				do: [ :e | 
					l remove: e.
					i value add: e ] ].
	^ o! !

!ABPackageList methodsFor: 'as yet unclassified' stamp: 'ThierryGoubier 7/14/2012 11:11'!
defaultTreeMorph
	^ super defaultTreeMorph
		doubleClickSelector: #doubleClick;
		nodeStringGetter: #asString;
		getMenuSelector: #menu:shifted:! !

!ABPackageList methodsFor: 'as yet unclassified' stamp: 'ThierryGoubier 7/14/2012 11:11'!
doubleClick
	self selectedNode ifNotNil: [:n | n doubleClick]! !

!ABPackageList methodsFor: 'as yet unclassified' stamp: 'ThierryGoubier 7/14/2012 11:11'!
keyStroke: anEvent from: aTreeMorph
	self selectedNode ifNotNil: [ :current | current keyStroke: anEvent from: aTreeMorph ]! !

!ABPackageList methodsFor: 'as yet unclassified' stamp: 'ThierryGoubier 7/14/2012 11:11'!
menu: menu shifted: b
	"Set up the menu to apply to the receiver's, 
	honoring the #shifted boolean"

	self selectedNode ifNotNil: [ :current | current menu: menu shifted: b ].
	^ menu! !

!ABPackageList methodsFor: 'as yet unclassified' stamp: 'ThierryGoubier 7/14/2012 11:12'!
open
	^ self openDialogWindowIn: World title: 'KSBrowser'.! !

!ABPackageList methodsFor: 'as yet unclassified' stamp: 'ThierryGoubier 7/15/2012 21:34'!
rootItems
	^ self class rootItems! !

!ABPackageList methodsFor: 'as yet unclassified' stamp: 'ThierryGoubier 7/15/2012 13:58'!
rootNodeClassFromItem: anItem
	^ ABPackageCategoryNode! !

TreeModel subclass: #ABTreeModel
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Alt-Browser'!

!ABTreeModel commentStamp: '<historical>' prior: 0!
An ABTreeModel is an extension of TreeModel to handle drag and drop.
!

!ABTreeModel class methodsFor: 'as yet unclassified' stamp: 'ThierryGoubier 7/16/2012 23:27'!
defaultSpec
	<spec>
	
	^ {#TreeSpec.
	    		#model:.							#model.
			#getLabelSelector:.				#wrapItem:.
			#getRootsSelector:.				#getRoots.
			#getChildrenSelector:.				#getChildrenFor:.
			#setSelectedSelector:.			#setSelectedItem:.
			#color:.							Color white.
			#getMenuSelector:.				#getMenu:.
			#hResizing:. 						#spaceFill.
			#vResizing:. 						#spaceFill.
			#eventHandler:.					{	#EventHandler. #on:send:to:. #keyStroke.	#keyStroke:fromMorph:. #model	}.
			#dropItemSelector:.				#dropItem:on:.
			#dragItemSelector:.				#dragItem:.}! !

!ABTreeModel methodsFor: 'as yet unclassified' stamp: 'ThierryGoubier 7/16/2012 23:29'!
dragItem: anItem
	(anItem isKindOf: Association)
		ifTrue: [ ^ anItem key ].
	^ anItem! !

!ABTreeModel methodsFor: 'as yet unclassified' stamp: 'ThierryGoubier 7/16/2012 23:27'!
dropItem: anItem on: aTarget
	^nil! !

Notification subclass: #OBAnnouncerRequest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Alt-Browser-Notifications'!

Notification subclass: #OBInteractionRequest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Alt-Browser-Notifications'!

!OBInteractionRequest commentStamp: 'cwp 12/7/2004 00:13' prior: 0!
OBInteractionRequest is an abstract superclass for notifications that request some interaction with the user. It's useful for catching such notifications in an exception handler, while allowing other notifications to operate normally.!

OBInteractionRequest subclass: #OBBrowseRequest
	instanceVariableNames: 'browser'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Alt-Browser-Notifications'!

!OBBrowseRequest commentStamp: 'cwp 12/7/2004 00:10' prior: 0!
This notification is raised whenever a browser needs to be opened. The default action is to open a SystemWindow in Morphic, but it can be caught in situations where that's not appropriate. The OB test suite uses this extensively. !

!OBBrowseRequest class methodsFor: 'exceptionInstantiator' stamp: 'cwp 10/17/2004 18:45'!
signal: aBrowser
	^ (self new browser: aBrowser) signal! !

!OBBrowseRequest methodsFor: 'accessing' stamp: 'cwp 10/17/2004 18:45'!
browser
	^ browser! !

!OBBrowseRequest methodsFor: 'accessing' stamp: 'lr 7/3/2009 22:27'!
browser: aBrowser 
	browser := aBrowser! !

!OBBrowseRequest methodsFor: 'dispatching' stamp: 'cwp 5/25/2007 22:51'!
handleWith: anObject
	^ anObject handleBrowseRequest: self! !

!OBBrowseRequest methodsFor: 'testing' stamp: 'cwp 10/17/2004 19:32'!
isBrowseRequest
	^ true! !

OBInteractionRequest subclass: #OBChoiceRequest
	instanceVariableNames: 'prompt labels values lines'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Alt-Browser-Notifications'!

!OBChoiceRequest commentStamp: 'cwp 3/5/2004 12:26' prior: 0!
This notification is used to ask the user for to choose from a list of alternatives. Its defaultAction is to open a PopUpMenu. Test cases an intercept the notification and respond programmatically.

prompt	- A string describing the choice the user is asked to make.
labels	- A list of strings describing the alternatives.
values	- When the user chooses an alternative, the corresponding item from this list is returned!

!OBChoiceRequest class methodsFor: 'exceptionInstantiator' stamp: 'cwp 7/9/2006 00:07'!
labels: anArray
	^ self
		prompt: nil
		labels: anArray
		values: anArray
		lines: #()! !

!OBChoiceRequest class methodsFor: 'exceptionInstantiator' stamp: 'cwp 7/9/2006 00:08'!
labels: labelArray lines: lineArray
	^ self
		prompt: nil
		labels: labelArray
		values: labelArray
		lines: lineArray! !

!OBChoiceRequest class methodsFor: 'exceptionInstantiator' stamp: 'cwp 7/9/2006 00:06'!
prompt: aString labels: labelArray values: valueArray
	^ self
		prompt: aString
		labels: labelArray
		 values: valueArray
		lines: #()! !

!OBChoiceRequest class methodsFor: 'exceptionInstantiator' stamp: 'cwp 7/9/2006 00:05'!
prompt: aString labels: labelArray values: valueArray lines: lineArray
	^ (self new 
		setPrompt: aString 
		labels: labelArray 
		values: valueArray 
		lines: lineArray) 
			signal! !

!OBChoiceRequest methodsFor: 'dispatching' stamp: 'cwp 6/1/2007 16:38'!
handleWith: anObject
	^ anObject handleChoiceRequest: self! !

!OBChoiceRequest methodsFor: 'accessing' stamp: 'cwp 7/8/2006 23:45'!
labels
	^ labels! !

!OBChoiceRequest methodsFor: 'accessing' stamp: 'cwp 7/9/2006 00:11'!
lines
	^ lines! !

!OBChoiceRequest methodsFor: 'accessing' stamp: 'cwp 7/8/2006 23:45'!
prompt
	^ prompt! !

!OBChoiceRequest methodsFor: 'signaling' stamp: 'lr 7/3/2009 22:27'!
select: aString 
	| index |
	index := labels indexOf: aString.
	self resume: (values 
			at: index
			ifAbsent: [ nil ])! !

!OBChoiceRequest methodsFor: 'initializing' stamp: 'lr 7/3/2009 22:27'!
setPrompt: aString labels: labelArray values: valueArray lines: lineArray 
	prompt := aString.
	labels := labelArray.
	values := valueArray.
	lines := lineArray! !

!OBChoiceRequest methodsFor: 'accessing' stamp: 'cwp 7/8/2006 23:45'!
values
	^ values! !

OBChoiceRequest subclass: #OBMultipleChoiceRequest
	instanceVariableNames: 'selection'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Alt-Browser-Notifications'!

!OBMultipleChoiceRequest methodsFor: 'dispatching' stamp: 'lr 4/5/2008 09:27'!
handleWith: anObject
	^ anObject handleMultipleChoiceRequest: self! !

!OBMultipleChoiceRequest methodsFor: 'accessing' stamp: 'lr 4/29/2010 09:34'!
label: anObject
	^ ((selection includes: anObject) ifTrue: [ '<yes>' ] ifFalse: [ '<no>' ]) , 
	  (labels at: (values indexOf: anObject ifAbsent: [ ^ nil ])) asString! !

!OBMultipleChoiceRequest methodsFor: 'accessing' stamp: 'lr 4/5/2008 10:30'!
selection
	^ selection! !

!OBMultipleChoiceRequest methodsFor: 'initializing' stamp: 'lr 4/5/2008 10:35'!
setPrompt: aString labels: labelArray values: valueArray lines: lineArray
	super setPrompt: aString labels: labelArray values: valueArray lines: lineArray.
	selection := IdentitySet withAll: valueArray! !

!OBMultipleChoiceRequest methodsFor: 'accessing' stamp: 'lr 4/5/2008 10:31'!
toggle: anObject
	(selection includes: anObject)
		ifTrue: [ selection remove: anObject ]
		ifFalse: [ selection add: anObject ]! !

OBInteractionRequest subclass: #OBCloseRequest
	instanceVariableNames: 'browser'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Alt-Browser-Notifications'!

!OBCloseRequest class methodsFor: 'exceptionInstantiator' stamp: 'avi 12/5/2007 13:17'!
signal: aBrowser
	^ (self new browser: aBrowser) signal! !

!OBCloseRequest methodsFor: 'accessing' stamp: 'avi 12/5/2007 13:17'!
browser
	^ browser! !

!OBCloseRequest methodsFor: 'accessing' stamp: 'lr 7/3/2009 22:27'!
browser: aBrowser 
	browser := aBrowser! !

!OBCloseRequest methodsFor: 'dispatching' stamp: 'avi 12/5/2007 13:17'!
handleWith: anObject
	^ anObject handleCloseRequest: self! !

OBInteractionRequest subclass: #OBCompletionRequest
	instanceVariableNames: 'prompt default assisted searchBlock labelBlock iconBlock'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Alt-Browser-Notifications'!

!OBCompletionRequest class methodsFor: 'utilities' stamp: 'lr 4/8/2011 19:39'!
subsequence: testString matches: aString caseSensitive: aBoolean
	"Checks if a testString is a subsequence of aString. The matching parts do not necessarily need to be consecutive, for example 'egli' matches 'renggli'."

	| index |
	index := 0.
	testString do: [ :char |
		index := aString
			findString: (String with: char)
			startingAt: index + 1
			caseSensitive: aBoolean.
		index = 0
			ifTrue: [ ^ false ] ].
	^ true! !

!OBCompletionRequest methodsFor: 'accessing' stamp: 'lr 9/22/2010 20:20'!
assisted
	^ assisted! !

!OBCompletionRequest methodsFor: 'accessing' stamp: 'lr 10/10/2010 18:17'!
assisted: aBoolean
	"A boolean indicating that the typing of the user is assisted but not constrained."
	
	assisted := aBoolean! !

!OBCompletionRequest methodsFor: 'configuration' stamp: 'lr 9/24/2010 21:41'!
collection: aCollection
	self collection: aCollection caseSensitive: false! !

!OBCompletionRequest methodsFor: 'configuration' stamp: 'lr 4/8/2011 19:39'!
collection: aCollection caseSensitive: aBoolean
	"Configure this completion dialog with aCollection and match the elements case sensitive if aBoolean is true. Display the complete list if the filter is empty."

	self searchBlock: [ :value |
		value isEmpty
			ifTrue: [ aCollection ]
			ifFalse: [
				aCollection select: [ :each |
					self class
						subsequence: value
						matches: (self labelFor: each)
						caseSensitive: aBoolean ] ] ]! !

!OBCompletionRequest methodsFor: 'accessing' stamp: 'lr 9/22/2010 20:04'!
default
	^ default! !

!OBCompletionRequest methodsFor: 'accessing' stamp: 'lr 9/22/2010 20:05'!
default: aString
	"The default string initially used for filtering."
	
	default := aString! !

!OBCompletionRequest methodsFor: 'dispatching' stamp: 'lr 9/22/2010 10:21'!
handleWith: anObject
	^ anObject handleCompletionRequest: self! !

!OBCompletionRequest methodsFor: 'accessing' stamp: 'lr 9/22/2010 10:11'!
iconBlock
	^ iconBlock! !

!OBCompletionRequest methodsFor: 'accessing' stamp: 'lr 9/22/2010 20:18'!
iconBlock: aOneArgumentBlock
	"A one argument block answering the icon symbol for a given element."
	
	iconBlock := aOneArgumentBlock! !

!OBCompletionRequest methodsFor: 'querying' stamp: 'lr 9/22/2010 20:27'!
iconFor: anObject
	^ iconBlock value: anObject! !

!OBCompletionRequest methodsFor: 'initialization' stamp: 'lr 9/22/2010 20:21'!
initialize
	super initialize.
	prompt := 'Completion Request'.
	default := String new.
	assisted := false.
	searchBlock := [ :value | #() ].
	labelBlock := [ :value | value asString ].
	iconBlock := [ :value | nil ]! !

!OBCompletionRequest methodsFor: 'accessing' stamp: 'lr 9/22/2010 10:11'!
labelBlock
	^ labelBlock! !

!OBCompletionRequest methodsFor: 'accessing' stamp: 'lr 9/22/2010 20:18'!
labelBlock: aOneArgumentBlock
	"A one argument block answering the string for a given element."
	
	labelBlock := aOneArgumentBlock! !

!OBCompletionRequest methodsFor: 'querying' stamp: 'lr 9/22/2010 20:06'!
labelFor: anObject
	^ labelBlock value: anObject! !

!OBCompletionRequest methodsFor: 'accessing' stamp: 'lr 9/22/2010 10:27'!
prompt
	^ prompt! !

!OBCompletionRequest methodsFor: 'accessing' stamp: 'lr 9/22/2010 20:19'!
prompt: aString
	"A string with the title for this request."
	
	prompt := aString! !

!OBCompletionRequest methodsFor: 'accessing' stamp: 'lr 9/22/2010 20:18'!
searchBlock
	^ searchBlock! !

!OBCompletionRequest methodsFor: 'accessing' stamp: 'lr 9/22/2010 20:19'!
searchBlock: aOneArgumentBlock
	"A one argument block returning the elements for the given filter."
	
	searchBlock := aOneArgumentBlock! !

!OBCompletionRequest methodsFor: 'querying' stamp: 'lr 9/22/2010 20:07'!
valuesFor: anObject
	^ searchBlock value: anObject! !

OBInteractionRequest subclass: #OBConfirmationRequest
	instanceVariableNames: 'prompt confirm cancel'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Alt-Browser-Notifications'!

!OBConfirmationRequest commentStamp: 'cwp 3/5/2004 12:30' prior: 0!
This notification is used to ask the user to confirm some kind potentially dangerous operation. Its default action is to open a PopUpMenu.

iVars:

prompt		- a string describing the situation the user is asked to confirm
confirm		- a string describing the action that will be taken if the user confirms
cancel		- a string describing the action that will be taken if the user does not confirm!

!OBConfirmationRequest class methodsFor: 'exceptionInstantiator' stamp: 'cwp 2/28/2004 12:09'!
newPrompt: prompt confirm: confirm cancel: cancel
	^ self new setPrompt: prompt confirm: confirm cancel: cancel! !

!OBConfirmationRequest class methodsFor: 'exceptionInstantiator' stamp: 'cwp 2/28/2004 12:13'!
prompt: prompt
	^ self prompt: prompt confirm: 'Ok'! !

!OBConfirmationRequest class methodsFor: 'exceptionInstantiator' stamp: 'cwp 2/28/2004 12:12'!
prompt: prompt confirm: confirm
	^ self prompt: prompt confirm: confirm cancel: 'Cancel'! !

!OBConfirmationRequest class methodsFor: 'exceptionInstantiator' stamp: 'cwp 2/28/2004 12:02'!
prompt: prompt confirm: confirm cancel: cancel
	^ (self newPrompt: prompt confirm: confirm cancel: cancel) signal! !

!OBConfirmationRequest methodsFor: 'responding' stamp: 'cwp 6/1/2007 16:58'!
cancel
	^ self resume: false! !

!OBConfirmationRequest methodsFor: 'accessing' stamp: 'cwp 6/1/2007 16:46'!
cancelChoice
	^ cancel! !

!OBConfirmationRequest methodsFor: 'dispatching' stamp: 'cwp 6/1/2007 16:40'!
handleWith: anObject
	^ anObject handleConfirmationRequest: self! !

!OBConfirmationRequest methodsFor: 'responding' stamp: 'cwp 2/28/2004 12:11'!
ok
	self resume: true! !

!OBConfirmationRequest methodsFor: 'accessing' stamp: 'cwp 6/1/2007 16:46'!
okChoice
	^ confirm! !

!OBConfirmationRequest methodsFor: 'accessing' stamp: 'cwp 6/1/2007 16:44'!
prompt
	^ prompt! !

!OBConfirmationRequest methodsFor: 'initalizing' stamp: 'lr 7/3/2009 22:27'!
setPrompt: promptString confirm: confirmString cancel: cancelString 
	prompt := promptString.
	confirm := confirmString.
	cancel := cancelString! !

OBInteractionRequest subclass: #OBInformRequest
	instanceVariableNames: 'message'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Alt-Browser-Notifications'!

!OBInformRequest class methodsFor: 'exceptionInstantiator' stamp: 'dc 7/22/2007 20:31'!
message: aString
	^ (self new
		message: aString;
		yourself) signal! !

!OBInformRequest methodsFor: 'dispatching' stamp: 'dc 7/22/2007 20:26'!
handleWith: anObject
	^ anObject handleInformRequest: self! !

!OBInformRequest methodsFor: 'accessing' stamp: 'dc 7/22/2007 20:28'!
message
	^ message! !

!OBInformRequest methodsFor: 'accessing' stamp: 'dc 7/22/2007 20:28'!
message: aString 
	message := aString! !

!OBInteractionRequest methodsFor: 'exceptionDescription' stamp: 'ThierryGoubier 7/16/2012 16:41'!
defaultAction
	^ self handleWith: RBPlatform current! !

!OBInteractionRequest methodsFor: 'dispatching' stamp: 'dc 7/22/2007 20:27'!
handleWith: anObject
	self subclassResponsibility ! !

!OBInteractionRequest methodsFor: 'testing' stamp: 'cwp 10/17/2004 19:31'!
isBrowseRequest
	^ false! !

OBInteractionRequest subclass: #OBMultiLineTextRequest
	instanceVariableNames: 'prompt template'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Alt-Browser-Notifications'!

!OBMultiLineTextRequest class methodsFor: 'exceptionInstantiator' stamp: 'dkh 12/19/2007 09:11'!
prompt: aString
	^ self prompt: aString template: ''! !

!OBMultiLineTextRequest class methodsFor: 'exceptionInstantiator' stamp: 'dkh 12/19/2007 09:11'!
prompt: promptString template: templateString
	^ (self new prompt: promptString; template: templateString) signal! !

!OBMultiLineTextRequest methodsFor: 'dispatching' stamp: 'dkh 12/19/2007 09:12'!
handleWith: anObject
	^ anObject handleMultiLineTextRequest: self! !

!OBMultiLineTextRequest methodsFor: 'accessing' stamp: 'dkh 12/19/2007 09:11'!
prompt
	^ prompt! !

!OBMultiLineTextRequest methodsFor: 'accessing' stamp: 'lr 7/3/2009 22:27'!
prompt: aString 
	prompt := aString! !

!OBMultiLineTextRequest methodsFor: 'accessing' stamp: 'dkh 12/19/2007 09:11'!
template
	^ template! !

!OBMultiLineTextRequest methodsFor: 'accessing' stamp: 'lr 7/3/2009 22:27'!
template: aString 
	template := aString! !

OBInteractionRequest subclass: #OBTextRequest
	instanceVariableNames: 'prompt template'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Alt-Browser-Notifications'!

!OBTextRequest commentStamp: 'cwp 3/5/2004 12:35' prior: 0!
This notification is used to ask the user to supply a short piece of text. Its defaultAction is to open a FillInTheBlank.

iVars:

prompt		- a string describing the text the user is asked to supply
template	- a default reply !

!OBTextRequest class methodsFor: 'exceptionInstantiator' stamp: 'dc 7/23/2007 16:51'!
prompt: aString
	^ self prompt: aString template: ''! !

!OBTextRequest class methodsFor: 'exceptionInstantiator' stamp: 'cwp 2/5/2004 20:31'!
prompt: promptString template: templateString
	^ (self new prompt: promptString; template: templateString) signal! !

!OBTextRequest methodsFor: 'dispatching' stamp: 'cwp 6/1/2007 16:40'!
handleWith: anObject
	^ anObject handleTextRequest: self! !

!OBTextRequest methodsFor: 'accessing' stamp: 'cwp 2/2/2004 21:24'!
prompt
	^ prompt! !

!OBTextRequest methodsFor: 'accessing' stamp: 'lr 7/3/2009 22:27'!
prompt: aString 
	prompt := aString! !

!OBTextRequest methodsFor: 'accessing' stamp: 'cwp 2/2/2004 21:00'!
template
	^ template! !

!OBTextRequest methodsFor: 'accessing' stamp: 'lr 7/3/2009 22:27'!
template: aString 
	template := aString! !

OBInteractionRequest subclass: #OBWaitRequest
	instanceVariableNames: 'block'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Alt-Browser-Notifications'!

!OBWaitRequest commentStamp: 'lr 5/14/2008 15:32' prior: 0!
This notification is used to tell the user to wait while some longer action is performed. The default action is to show a hourglass instead of the normal cursor.

iVars:

block		- the code to execute!

!OBWaitRequest class methodsFor: 'instance-creation' stamp: 'lr 5/14/2008 15:47'!
block: aBlock
	^ self new block: aBlock; signal! !

!OBWaitRequest methodsFor: 'accessing' stamp: 'lr 5/14/2008 15:41'!
block
	^ block! !

!OBWaitRequest methodsFor: 'accessing' stamp: 'lr 5/14/2008 15:41'!
block: aBlock
	block := aBlock! !

!OBWaitRequest methodsFor: 'dispatching' stamp: 'lr 5/14/2008 15:41'!
handleWith: anObject
	^ anObject handleWaitRequest: self! !

ComposableModel subclass: #AltBrowser
	instanceVariableNames: 'treeModel methodModel textModel'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Alt-Browser'!

!AltBrowser commentStamp: '<historical>' prior: 0!
An AltBrowser is the main application.

Instance Variables
	methodModel:		<A method model>
	treeModel:		<An ABPackageList>

methodModel
	- handle the display of methods.

treeModel
	- handle navigation between packages/category/classes/protocols/methods
!

!AltBrowser class methodsFor: 'as yet unclassified' stamp: 'ThierryGoubier 7/16/2012 22:39'!
defaultSpec
	<spec>
	
	^ {#ComposableSpec.
			#add:. {
				{#model. #treeModel}.
				#layout:.
				{#FrameLayout. #fractions:offsets:. (0 @ 0 corner: 0.3 @ 1). (0 @ 0 corner: 0 @ 0)}
			}.
			#add:. {
				{#model. #textModel}.
				#layout:.
				{#FrameLayout. #fractions:offsets:. (0.3 @ 0 corner: 1 @ 1). (0 @ 0 corner: 0 @ 0)}
			}
		}! !

!AltBrowser class methodsFor: 'as yet unclassified' stamp: 'ThierryGoubier 7/15/2012 22:44'!
title
	^ 'Alt Browser'! !

!AltBrowser methodsFor: 'as yet unclassified' stamp: 'ThierryGoubier 7/16/2012 14:15'!
initializePresenter
	treeModel roots: (ABPackageList rootItems collect: [ :e | ABPackageCategoryNode with: e model: self ]).
	treeModel childrenBlock: [ :it | it contents ].
	treeModel displayBlock: [ :it | it asString ].
	treeModel
		whenSelectedItemChanged: [ :sel | 
			sel isNil
				ifTrue: [ 
					textModel text: ''.
					textModel behavior: nil ]
				ifFalse: [ 
					textModel text: sel sourceCode.
					textModel behavior: sel sourceClass ] ]! !

!AltBrowser methodsFor: 'as yet unclassified' stamp: 'ThierryGoubier 7/16/2012 22:44'!
initializeWidgets
	self instantiateModels: #(#treeModel #ABTreeModel #textModel #TextModel).
	textModel aboutToStyle: true! !

!AltBrowser methodsFor: 'as yet unclassified' stamp: 'ThierryGoubier 7/16/2012 00:35'!
textModel
	^textModel! !

!AltBrowser methodsFor: 'as yet unclassified' stamp: 'ThierryGoubier 7/15/2012 22:41'!
treeModel
	^treeModel! !

Object subclass: #OBAnnouncement
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Alt-Browser-Announcements'!

OBAnnouncement subclass: #OBAboutToChange
	instanceVariableNames: 'veto'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Alt-Browser-Announcements'!

!OBAboutToChange methodsFor: 'vetos' stamp: 'cwp 4/17/2006 22:18'!
isVetoed
	^ veto notNil! !

!OBAboutToChange methodsFor: 'vetos' stamp: 'lr 7/3/2009 22:27'!
veto
	veto := true! !

OBAnnouncement subclass: #OBAboutToChangeSilently
	instanceVariableNames: 'veto'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Alt-Browser-Announcements'!

!OBAboutToChangeSilently methodsFor: 'vetos' stamp: 'cwp 3/3/2007 22:28'!
isVetoed
	^ veto notNil! !

!OBAboutToChangeSilently methodsFor: 'vetos' stamp: 'lr 7/3/2009 22:27'!
veto
	veto := true! !

OBAnnouncement subclass: #OBChildrenChanged
	instanceVariableNames: 'node'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Alt-Browser-Announcements'!

!OBChildrenChanged class methodsFor: 'instance creation' stamp: 'cwp 6/5/2006 00:49'!
node: aNode
	^ self new node: aNode! !

!OBChildrenChanged methodsFor: 'accessing' stamp: 'cwp 6/5/2006 00:49'!
node
	^ node! !

!OBChildrenChanged methodsFor: 'accessing' stamp: 'lr 7/3/2009 22:27'!
node: aNode 
	node := aNode! !

OBAnnouncement subclass: #OBCommandScan
	instanceVariableNames: 'factories'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Alt-Browser-Announcements'!

!OBCommandScan methodsFor: 'accessing' stamp: 'lr 8/8/2010 10:52'!
addCommandsOn: aNode for: aRequestor to: aSet 
	| cmd |
	factories do: 
		[ :ea | 
		cmd := ea 
			on: aNode
			for: aRequestor.
		(cmd wantsMenu and: [ cmd isActive ])
			ifTrue: [ aSet add: cmd ] ]! !

!OBCommandScan methodsFor: 'accessing' stamp: 'cwp 11/2/2006 00:35'!
addFactory: aCommandFactory 
	factories add: aCommandFactory! !

!OBCommandScan methodsFor: 'user interface' stamp: 'lr 3/4/2009 08:32'!
clusterCommands: aCollection 
	| groups root name cluster |
	groups := IdentityDictionary new.
	root := OBCommandCluster new.
	aCollection do: 
		[ :command | 
		name := command cluster.
		cluster := name isNil 
			ifTrue: [ root ]
			ifFalse: 
				[ groups 
					at: name
					ifAbsentPut: [ command createCluster ] ].
		cluster addCommand: command ].
	groups values do: [ :ea | root addCommand: ea ].
	^ root! !

!OBCommandScan methodsFor: 'accessing' stamp: 'cwp 11/2/2006 00:30'!
commandsOn: aNode for: aRequestor
	^ factories collect: [:ea | ea on: aNode for: aRequestor]! !

!OBCommandScan methodsFor: 'initialize-release' stamp: 'lr 7/3/2009 22:27'!
initialize
	factories := OrderedCollection new! !

!OBCommandScan methodsFor: 'user interface' stamp: 'lr 7/3/2009 22:27'!
populateMenu: aMenu withNodes: aCollection forRequestor: aRequestor 
	| commands cluster |
	commands := IdentitySet new.
	aCollection do: 
		[ :node | 
		self 
			addCommandsOn: node
			for: aRequestor
			to: commands ].
	cluster := self clusterCommands: commands.
	cluster populateMenu: aMenu! !

!OBCommandScan methodsFor: 'user interface' stamp: 'lr 4/25/2011 10:54'!
processKeystroke: aKeystroke withNode: aNode for: aRequestor
	((self commandsOn: aNode for: aRequestor)
		select: [ :each | each keystroke asKeystroke = aKeystroke ])
		do: [ :each | 
			(each isActive and: [ each isEnabled ]) ifTrue: [
				each execute. 
				^ true ] ].
	^ false! !

OBCommandScan subclass: #OBNodeCommandScan
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Alt-Browser-Announcements'!

OBCommandScan subclass: #OBTextCommandScan
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Alt-Browser-Announcements'!

OBAnnouncement subclass: #OBDefinitionChanged
	instanceVariableNames: 'definition node'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Alt-Browser-Announcements'!

!OBDefinitionChanged class methodsFor: 'instance creation' stamp: 'cwp 6/4/2006 11:28'!
definition: aDefinition
	^ self new
		definition: aDefinition;
		yourself! !

!OBDefinitionChanged class methodsFor: 'instance creation' stamp: 'cwp 6/4/2006 11:27'!
node: aNode definition: aDefinition
	^ self new
		node: aNode;
		definition: aDefinition;
		yourself! !

!OBDefinitionChanged methodsFor: 'accessing' stamp: 'cwp 6/4/2006 11:25'!
definition
	^ definition! !

!OBDefinitionChanged methodsFor: 'accessing' stamp: 'lr 7/3/2009 22:27'!
definition: aDefinition 
	definition := aDefinition! !

!OBDefinitionChanged methodsFor: 'accessing' stamp: 'cwp 6/5/2006 00:47'!
node
	^ node! !

!OBDefinitionChanged methodsFor: 'accessing' stamp: 'lr 7/3/2009 22:27'!
node: aNode 
	node := aNode! !

OBAnnouncement subclass: #OBNavigate
	instanceVariableNames: 'bid action fan label'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Alt-Browser-Standard-Announcements'!

!OBNavigate class methodsFor: 'instance creation' stamp: 'dr 9/17/2008 14:02'!
of: aNode
	^ self new setRoot: aNode! !

!OBNavigate class methodsFor: 'instance creation' stamp: 'dr 2/10/2009 16:25'!
of: aNode label: aString
	^(self of: aNode) label: aString; yourself! !

!OBNavigate methodsFor: 'execution' stamp: 'lr 3/21/2009 20:03'!
bid: anInteger toDo: aBlock 
	anInteger > bid ifFalse: [ ^ self ].
	bid := anInteger.
	action := aBlock! !

!OBNavigate methodsFor: 'accessing' stamp: 'lr 3/4/2009 22:08'!
browserClass
	self subclassResponsibility! !

!OBNavigate methodsFor: 'configuration' stamp: 'lr 3/4/2009 08:24'!
defaultAction
	^ [fan children isEmpty
		ifTrue: [OBInformRequest message: self noChildrenMessage]
		ifFalse: [self browserClass browseRoot: fan parent label: self label]]! !

!OBNavigate methodsFor: 'configuration' stamp: 'dr 10/1/2007 16:28'!
defaultMetaNode
	^self browserClass defaultMetaNode! !

!OBNavigate methodsFor: 'execution' stamp: 'cwp 8/20/2007 22:51'!
execute
	^ action value! !

!OBNavigate methodsFor: 'accessing' stamp: 'cwp 8/20/2007 23:10'!
fan
	^ fan! !

!OBNavigate methodsFor: 'initialize-release' stamp: 'cwp 8/20/2007 22:52'!
initialize
	bid := 0.
	action := self defaultAction! !

!OBNavigate methodsFor: 'accessing' stamp: 'dr 2/10/2009 16:25'!
label
	^label! !

!OBNavigate methodsFor: 'accessing' stamp: 'dr 2/10/2009 16:25'!
label: aString
	label := aString! !

!OBNavigate methodsFor: 'accessing' stamp: 'lr 3/4/2009 22:13'!
noChildrenMessage
	self subclassResponsibility! !

!OBNavigate methodsFor: 'accessing' stamp: 'cwp 8/26/2007 00:30'!
setRoot: aNode 
	fan := (aNode copy metaNode: self defaultMetaNode) asFan! !

OBNavigate subclass: #OBShowHierarchyImplementors
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Alt-Browser-Standard-Announcements'!

!OBShowHierarchyImplementors methodsFor: 'accessing' stamp: 'ThierryGoubier 7/16/2012 16:47'!
browserClass
	self halt"^ OBHierarchyImplementorsBrowser"! !

!OBShowHierarchyImplementors methodsFor: 'accessing' stamp: 'lr 8/2/2010 16:41'!
noChildrenMessage
	^ 'No hierarchy implementors'! !

OBNavigate subclass: #OBShowHierarchySenders
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Alt-Browser-Standard-Announcements'!

!OBShowHierarchySenders methodsFor: 'accessing' stamp: 'ThierryGoubier 7/16/2012 16:47'!
browserClass
	self halt"^ OBHierarchySendersBrowser"! !

!OBShowHierarchySenders methodsFor: 'accessing' stamp: 'lr 8/2/2010 16:41'!
noChildrenMessage
	^ 'No hierarchy senders'! !

OBNavigate subclass: #OBShowImplementors
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Alt-Browser-Standard-Announcements'!

!OBShowImplementors methodsFor: 'accessing' stamp: 'ThierryGoubier 7/16/2012 16:48'!
browserClass
	self halt"^ OBImplementorsBrowser"! !

!OBShowImplementors methodsFor: 'accessing' stamp: 'lr 8/2/2010 16:41'!
noChildrenMessage
	^ 'No implementors'! !

OBNavigate subclass: #OBShowSenders
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Alt-Browser-Standard-Announcements'!

!OBShowSenders methodsFor: 'accessing' stamp: 'ThierryGoubier 7/16/2012 16:48'!
browserClass
	self halt"^ OBSendersBrowser"! !

!OBShowSenders methodsFor: 'accessing' stamp: 'lr 8/2/2010 16:42'!
noChildrenMessage
	^ 'No senders'! !

OBAnnouncement subclass: #OBNodeChanged
	instanceVariableNames: 'node'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Alt-Browser-Announcements'!

!OBNodeChanged class methodsFor: 'instance creation' stamp: 'cwp 6/4/2006 11:17'!
node: aNode
	^ self new node: aNode! !

!OBNodeChanged methodsFor: 'accessing' stamp: 'cwp 6/4/2006 11:17'!
node
	^ node! !

!OBNodeChanged methodsFor: 'accessing' stamp: 'lr 7/3/2009 22:27'!
node: aNode 
	node := aNode! !

OBAnnouncement subclass: #OBNodeCreated
	instanceVariableNames: 'node'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Alt-Browser-Announcements'!

!OBNodeCreated class methodsFor: 'instance creation' stamp: 'cwp 6/4/2006 01:09'!
node: aNode
	^ self new node: aNode! !

!OBNodeCreated methodsFor: 'accessing' stamp: 'cwp 6/4/2006 00:53'!
node
	^ node! !

!OBNodeCreated methodsFor: 'accessing' stamp: 'lr 7/3/2009 22:27'!
node: aNode 
	node := aNode! !

OBAnnouncement subclass: #OBNodeDeleted
	instanceVariableNames: 'node'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Alt-Browser-Announcements'!

!OBNodeDeleted class methodsFor: 'instance creation' stamp: 'cwp 6/4/2006 11:56'!
node: aNode
	^ self new node: aNode! !

!OBNodeDeleted methodsFor: 'accessing' stamp: 'cwp 6/4/2006 11:56'!
node
	^ node! !

!OBNodeDeleted methodsFor: 'accessing' stamp: 'lr 7/3/2009 22:27'!
node: aNode 
	node := aNode! !

OBAnnouncement subclass: #OBRefreshRequired
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Alt-Browser-Announcements'!

OBAnnouncement subclass: #OBSelectingNode
	instanceVariableNames: 'node'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Alt-Browser-Announcements'!

!OBSelectingNode class methodsFor: 'instance creation' stamp: 'cwp 6/4/2006 13:58'!
node: aNode
	^ self new node: aNode! !

!OBSelectingNode methodsFor: 'accessing' stamp: 'cwp 6/4/2006 13:58'!
node
	^ node! !

!OBSelectingNode methodsFor: 'accessing' stamp: 'lr 7/3/2009 22:27'!
node: aNode 
	node := aNode! !

OBAnnouncement subclass: #OBSelectionChanged
	instanceVariableNames: 'node column'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Alt-Browser-Announcements'!

!OBSelectionChanged class methodsFor: 'instance creation' stamp: 'cwp 4/19/2006 00:51'!
column: aColumn 
	^ self new column: aColumn! !

!OBSelectionChanged class methodsFor: 'instance creation' stamp: 'cwp 4/19/2006 00:31'!
node: aNode
	^ self new node: aNode! !

!OBSelectionChanged methodsFor: 'accessing' stamp: 'cwp 4/19/2006 00:53'!
column
	^ column! !

!OBSelectionChanged methodsFor: 'accessing' stamp: 'lr 7/3/2009 22:27'!
column: aColumn 
	column := aColumn! !

!OBSelectionChanged methodsFor: 'accessing' stamp: 'lr 3/4/2009 08:32'!
node
	^ column isNil 
		ifTrue: [ node ]
		ifFalse: [ column selectedNode ]! !

!OBSelectionChanged methodsFor: 'accessing' stamp: 'lr 7/3/2009 22:27'!
node: aNode 
	node := aNode! !

Object subclass: #OBAnnouncer
	instanceVariableNames: 'subscriptions'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Alt-Browser-Announcements'!

!OBAnnouncer class methodsFor: 'instance creation' stamp: 'cwp 6/4/2006 00:55'!
current
	^ OBAnnouncerRequest signal! !

!OBAnnouncer class methodsFor: 'instance creation' stamp: 'cwp 4/17/2006 11:50'!
new
	^ self basicNew initialize! !

!OBAnnouncer methodsFor: 'subscription' stamp: 'lr 4/18/2011 22:28'!
announce: anObject
	| ann |
	ann := anObject asAnnouncement.
	subscriptions keysAndValuesDo: [ :class :action |
		(ann isKindOf: class)
			ifTrue: [ action valueWithArguments: (Array with: ann) ] ].
	^ ann! !

!OBAnnouncer methodsFor: 'initialize-release' stamp: 'lr 7/3/2009 22:27'!
initialize
	subscriptions := IdentityDictionary new! !

!OBAnnouncer methodsFor: 'subscription' stamp: 'GuillermoPolito 1/17/2012 12:20'!
on: aClass do: aValuable 
	| actions |
	actions := subscriptions 
		at: aClass
		ifAbsent: [ WeakActionSequence new ].
	subscriptions 
		at: aClass
		put: (actions copyWith: aValuable)! !

!OBAnnouncer methodsFor: 'subscription' stamp: 'lr 4/18/2011 22:28'!
on: aClass send: aSelector to: anObject
	self
		on: aClass
		do: (MessageSend receiver: anObject selector: aSelector)! !

!OBAnnouncer methodsFor: 'accessing' stamp: 'lr 4/3/2010 17:50'!
subscriptions
	^ subscriptions! !

!OBAnnouncer methodsFor: 'subscription' stamp: 'cwp 6/10/2006 00:40'!
unsubscribe: anObject
	subscriptions keysAndValuesDo:
		[:class :actions |
		subscriptions at: class put: (actions reject: [:ea | ea receiver == anObject])].
	subscriptions keysAndValuesRemove: [:key :value | value isEmpty]! !

Object subclass: #OBCommand
	instanceVariableNames: 'target requestor'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Alt-Browser-Commands'!

OBCommand subclass: #OBAcceptTextCommand
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Alt-Browser-Commands'!

!OBAcceptTextCommand classSide methodsFor: 'testing' stamp: 'lr 12/10/2010 09:25'!
takesNodes
	^ false! !

!OBAcceptTextCommand classSide methodsFor: 'testing' stamp: 'lr 12/10/2010 09:25'!
takesText
	^ true! !

!OBAcceptTextCommand methodsFor: 'execution' stamp: 'lr 12/10/2010 09:10'!
execute
	target accept! !

!OBAcceptTextCommand methodsFor: 'accessing' stamp: 'lr 12/10/2010 10:39'!
group
	^ #zip! !

!OBAcceptTextCommand methodsFor: 'accessing' stamp: 'lr 5/9/2011 18:51'!
icon
	^ #okIcon! !

!OBAcceptTextCommand methodsFor: 'testing' stamp: 'lr 12/10/2010 09:21'!
isActive
	^ true! !

!OBAcceptTextCommand methodsFor: 'accessing' stamp: 'lr 12/10/2010 10:30'!
keystroke
	^ $s! !

!OBAcceptTextCommand methodsFor: 'accessing' stamp: 'lr 12/10/2010 09:09'!
label
	^ 'Accept'! !

OBCommand subclass: #OBCancelTextCommand
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Alt-Browser-Commands'!

!OBCancelTextCommand classSide methodsFor: 'testing' stamp: 'lr 12/10/2010 09:25'!
takesNodes
	^ false! !

!OBCancelTextCommand classSide methodsFor: 'testing' stamp: 'lr 12/10/2010 09:25'!
takesText
	^ true! !

!OBCancelTextCommand methodsFor: 'execution' stamp: 'lr 12/10/2010 09:11'!
execute
	target cancel! !

!OBCancelTextCommand methodsFor: 'accessing' stamp: 'lr 12/10/2010 10:39'!
group
	^ #zip! !

!OBCancelTextCommand methodsFor: 'accessing' stamp: 'lr 5/9/2011 18:51'!
icon
	^ #cancelIcon! !

!OBCancelTextCommand methodsFor: 'testing' stamp: 'lr 12/10/2010 09:22'!
isActive
	^ true! !

!OBCancelTextCommand methodsFor: 'accessing' stamp: 'lr 12/10/2010 09:11'!
keystroke
	^ $l! !

!OBCancelTextCommand methodsFor: 'accessing' stamp: 'lr 12/10/2010 09:11'!
label
	^ 'Cancel'! !

OBCommand subclass: #OBCategoryCommand
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Alt-Browser-Standard-Commands'!

!OBCategoryCommand methodsFor: 'accessing' stamp: 'avi 5/30/2007 23:07'!
group
	^ #category! !

!OBCategoryCommand methodsFor: 'testing' stamp: 'lr 11/8/2009 10:02'!
isActive
	^ target hasOrganization and: [ (requestor isSelected: target) not ]! !

OBCategoryCommand subclass: #OBCmdCreateCategory
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Alt-Browser-Standard-Commands'!

!OBCmdCreateCategory methodsFor: 'accessing' stamp: 'lr 9/22/2010 21:09'!
categories
	^ self subclassResponsibility! !

!OBCmdCreateCategory methodsFor: 'execution' stamp: 'lr 11/26/2010 11:32'!
execute
	| categories category before |
	categories := self categories sorted.
	category := OBCompletionRequest new
		assisted: true;
		collection: categories;
		prompt: 'Add Category';
		signal.
	category isNil ifTrue: [ ^ self ].
	before := requestor children
		at: requestor selection + 1
		ifAbsent: [ nil ].
	target organization
		addCategory: category
		before: (before isNil
			ifFalse: [ before name ]).
	self 
		select: (target categoryNodeNamed: category)
		with: requestor announcer! !

!OBCmdCreateCategory methodsFor: 'accessing' stamp: 'lr 9/22/2010 21:07'!
icon
	^ #newIcon! !

!OBCmdCreateCategory methodsFor: 'accessing' stamp: 'lr 9/25/2010 22:28'!
label
	^ 'Add category...'! !

OBCmdCreateCategory subclass: #OBCmdCreateClassCategory
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Alt-Browser-Standard-Commands'!

!OBCmdCreateClassCategory methodsFor: 'accessing' stamp: 'lr 9/24/2010 08:06'!
categories
	| categories |
	categories := Set new.
	PackageOrganizer default packages
		do: [ :package | categories add: package systemCategoryPrefix ].
	target categories
		do: [ :node | categories add: node name ].
	^ categories! !

!OBCmdCreateClassCategory methodsFor: 'testing' stamp: 'ThierryGoubier 7/16/2012 16:23'!
isActive
	^ super isActive and: [ (target isKindOf: ABClassCategoryNode)" or: [ target isKindOf: OBEnvironmentNode ]" ]! !

OBCmdCreateCategory subclass: #OBCmdCreateMethodCategory
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Alt-Browser-Standard-Commands'!

!OBCmdCreateMethodCategory methodsFor: 'accessing' stamp: 'lr 9/24/2010 08:07'!
categories
	| categories |
	categories := Set new.
	target theClass withAllSuperclasses do: [ :class | 
		class organization categories do: [ :each |
			categories add: each asLowercase ] ].
	PackageOrganizer default packages
		do: [ :package | categories add: package methodCategoryPrefix ].
	categories
		remove: ClassOrganizer nullCategory ifAbsent: [ ];
		remove: ClassOrganizer default ifAbsent: [ ].
	^ categories! !

!OBCmdCreateMethodCategory methodsFor: 'testing' stamp: 'ThierryGoubier 7/16/2012 16:34'!
isActive
	^ super isActive and: [ requestor selectedNode isKindOf: ABMethodCategoryNode ]! !

OBCategoryCommand subclass: #OBCmdPromoteCategories
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Alt-Browser-Standard-Commands'!

!OBCmdPromoteCategories methodsFor: 'execution' stamp: 'lr 3/6/2011 16:39'!
execute
	| organizer match categories matchingCategories newCategories selectedCategory template |
	selectedCategory := (requestor notNil and: [ requestor class canUnderstand: #descriptor ])
		ifTrue: [ requestor descriptor asSymbol ]
		ifFalse: [ #Package ].
	template := (selectedCategory includes: $-)
		ifTrue: [ selectedCategory copyUpTo: $- ]
		ifFalse: [ selectedCategory ].
	template := template , '*'.
	match := OBTextRequest prompt: 'Enter a matching expression' template: template.
	(match isNil or: [ match isEmpty ])
		ifTrue: [ ^ self ].
	organizer := target organization.
	categories := organizer categories.
	matchingCategories := categories select: [ :c | match match: c ].
	newCategories := matchingCategories , (categories copyWithoutAll: matchingCategories).
	target organization categories: newCategories.
	requestor browser announce: OBRefreshRequired! !

!OBCmdPromoteCategories methodsFor: 'testing' stamp: 'ThierryGoubier 7/16/2012 16:23'!
isActive
	^ super isActive and: [ requestor selectedNode isKindOf: ABClassCategoryNode ]! !

!OBCmdPromoteCategories methodsFor: 'accessing' stamp: 'lr 8/8/2010 10:07'!
label
	^ 'Promote categories...'! !

OBCategoryCommand subclass: #OBCmdRemoveEmptyCats
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Alt-Browser-Standard-Commands'!

!OBCmdRemoveEmptyCats methodsFor: 'execution' stamp: 'lr 6/21/2009 17:07'!
execute
	target organization removeEmptyCategories.
	requestor browser announce: OBRefreshRequired! !

!OBCmdRemoveEmptyCats methodsFor: 'accessing' stamp: 'lr 8/8/2010 10:07'!
label
	^ 'Remove empty categories'! !

OBCategoryCommand subclass: #OBCmdRenameCategory
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Alt-Browser-Standard-Commands'!

!OBCmdRenameCategory methodsFor: 'accessing' stamp: 'lr 9/22/2010 21:18'!
categories
	^ self subclassResponsibility! !

!OBCmdRenameCategory methodsFor: 'execution' stamp: 'lr 9/24/2010 21:57'!
execute
	| categories category |
	categories := self categories sorted.
	category := OBCompletionRequest new
		assisted: true;
		default: target name;
		collection: categories;
		prompt: 'Rename Category';
		signal.
	category isNil ifTrue: [ ^ self ].
	target renameTo: category.
	self 
		select: (target setName: category)
		with: requestor announcer! !

!OBCmdRenameCategory methodsFor: 'testing' stamp: 'lr 9/22/2010 21:28'!
isActive
	^ requestor isSelected: target! !

!OBCmdRenameCategory methodsFor: 'accessing' stamp: 'lr 8/8/2010 10:07'!
label
	^ 'Rename category...'! !

OBCmdRenameCategory subclass: #OBCmdRenameClassCategory
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Alt-Browser-Standard-Commands'!

!OBCmdRenameClassCategory methodsFor: 'accessing' stamp: 'lr 9/22/2010 22:11'!
categories
	^ requestor parent categories collect: [ :each | each name ]! !

!OBCmdRenameClassCategory methodsFor: 'testing' stamp: 'ThierryGoubier 7/16/2012 16:23'!
isActive
	^ super isActive and: [ target isKindOf: ABClassCategoryNode ]! !

OBCmdRenameCategory subclass: #OBCmdRenameMethodCategory
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Alt-Browser-Standard-Commands'!

!OBCmdRenameMethodCategory methodsFor: 'accessing' stamp: 'lr 9/22/2010 21:39'!
categories
	| categories |
	categories := Set new.
	target theClass allSuperclasses
		do: [ :each | categories addAll: each organization categories ].
	PackageOrganizer default packages
		do: [ :each | categories add: each methodCategoryPrefix ].
	target theClass organization categories
		do: [ :each | categories remove: each ifAbsent: [ ] ].
	categories
		remove: ClassOrganizer nullCategory ifAbsent: [ ];
		remove: ClassOrganizer default ifAbsent: [ ].
	^ categories! !

!OBCmdRenameMethodCategory methodsFor: 'testing' stamp: 'ThierryGoubier 7/16/2012 16:14'!
isActive
	^ super isActive and: [ target isKindOf: ABMethodCategoryNode ]! !

OBCategoryCommand subclass: #OBCmdReorgCats
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Alt-Browser-Standard-Commands'!

!OBCmdReorgCats methodsFor: 'execution' stamp: 'cwp 10/15/2006 18:53'!
execute
	| definition organizer |
	organizer := target organization.
	definition := OBOrganizationDefinition on: organizer.
	requestor announce: definition! !

!OBCmdReorgCats methodsFor: 'accessing' stamp: 'lr 8/8/2010 10:07'!
label
	^ 'Reorganize categories'! !

OBCommand subclass: #OBCmdAutoCategorize
	instanceVariableNames: ''
	classVariableNames: 'CategorizationRules IgnoredCategories'
	poolDictionaries: ''
	category: 'Alt-Browser-Standard-Commands'!

!OBCmdAutoCategorize class methodsFor: 'private' stamp: 'lr 9/22/2010 09:07'!
commonProtocolFor: aSelector in: aClass
	| protocols protocol |
	protocols := Bag new.
	self environment allClassesAndTraitsDo: [ :behavior |
		| class |
		class := aClass isMeta
			ifTrue: [ behavior theMetaClass ]
			ifFalse: [ behavior theNonMetaClass ].
		(class includesSelector: aSelector) ifTrue: [
			protocol := class organization categoryOfElement: aSelector.
			(self isValidProtocol: protocol)
				ifTrue: [ protocols add: protocol ] ] ].
	protocols isEmpty
		ifTrue: [ ^ nil ].
	protocol := protocols sortedCounts first.
	^ protocol key >= 5 ifTrue: [ protocol value ]! !

!OBCmdAutoCategorize class methodsFor: 'initialization' stamp: 'lr 12/1/2010 19:01'!
initialize
	IgnoredCategories := Array with: Categorizer default with: Categorizer allCategory with: Categorizer nullCategory.
	CategorizationRules := OrderedCollection new.
	CategorizationRules
		add: [ :class :selector | self superclassProtocolFor: selector in: class ];
		add: [ :class :selector | (selector beginsWith: 'add') ifTrue: [ #adding ] ];
		add: [ :class :selector | (selector beginsWith: 'as') ifTrue: [ #converting ] ];
		add: [ :class :selector | (selector beginsWith: 'accept') ifTrue: [ #visiting ] ];
		add: [ :class :selector | (selector beginsWith: 'remove') ifTrue: [ #removing ] ];
		add: [ :class :selector | (selector beginsWith: 'render') ifTrue: [ #rendering ] ];
		add: [ :class :selector | (selector beginsWith: 'initialize') ifTrue: [ #initialization ] ];
		add: [ :class :selector | ((selector beginsWith: 'is') or: [ selector beginsWith: 'has' ]) ifTrue: [ #testing ] ];
		add: [ :class :selector | ((class includesBehavior: TestCase) and: [ selector beginsWith: 'test' ]) ifTrue: [ #tests ] ];
		add: [ :class :selector | ((selector beginsWith: 'basic') or: [ (selector beginsWith: 'private') or: [ selector beginsWith: 'primitive' ] ]) ifTrue: [ #private ] ];
		add: [ :class :selector | (class isMeta and: [ (selector beginsWith: 'new') or: [ (selector beginsWith: 'on') or: [ selector beginsWith: 'with' ] ] ]) ifTrue: [ #'instance creation' ] ];
		add: [ :class :selector | ((selector numArgs = 0 and: [ class allInstVarNames includes: selector asString ]) or: [ selector numArgs = 1 and: [ class allInstVarNames includes: selector asString allButLast ] ]) ifTrue: [ #accessing ] ];
		
		add: [ :class :selector | self commonProtocolFor: selector in: class ]! !

!OBCmdAutoCategorize class methodsFor: 'testing' stamp: 'lr 9/22/2010 08:55'!
isValidProtocol: aSymbol
	^ aSymbol notNil and: [ (aSymbol beginsWith: '*') not and: [ (IgnoredCategories includes: aSymbol) not ] ]! !

!OBCmdAutoCategorize class methodsFor: 'private' stamp: 'lr 9/22/2010 09:08'!
superclassProtocolFor: aSelector in: aClass
	aClass allSuperclassesDo: [ :class |
		| protocol |
		protocol := class organization categoryOfElement: aSelector.
		(self isValidProtocol: protocol) 
			ifTrue: [ ^ protocol ].
		class theNonMetaClass = ProtoObject
			ifTrue: [ ^ nil ] ].
	^ nil! !

!OBCmdAutoCategorize methodsFor: 'execution' stamp: 'lr 9/22/2010 08:52'!
categorize: aSelector
	CategorizationRules do: [ :rule |
		| result |
		result := rule value: target theClass value: aSelector.
		result isNil 
			ifFalse: [ ^ self organization classify: aSelector under: result ] ]! !

!OBCmdAutoCategorize methodsFor: 'execution' stamp: 'lr 8/17/2010 18:33'!
execute
	(self organization listAtCategoryNamed: ClassOrganizer default) 
		do: [ :each | self categorize: each ]! !

!OBCmdAutoCategorize methodsFor: 'accessing' stamp: 'cwp 10/9/2006 15:07'!
group
	^ #category! !

!OBCmdAutoCategorize methodsFor: 'testing' stamp: 'lr 9/22/2010 08:57'!
isActive
	^ target hasOrganization and: [ target organization isClassOrganizer and: [ (requestor isSelected: target) not ] ]! !

!OBCmdAutoCategorize methodsFor: 'accessing' stamp: 'lr 8/8/2010 10:07'!
label
	^ 'Categorize automatically'! !

!OBCmdAutoCategorize methodsFor: 'accessing' stamp: 'lr 8/17/2010 18:33'!
organization
	^ target organization! !

OBCommand subclass: #OBCmdBrowse
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Alt-Browser-Standard-Commands'!

!OBCmdBrowse methodsFor: 'execution' stamp: 'dr 9/5/2008 11:23'!
execute 
	target browse! !

!OBCmdBrowse methodsFor: 'accessing' stamp: 'cwp 10/9/2006 17:56'!
group
	^ #navigation! !

!OBCmdBrowse methodsFor: 'testing' stamp: 'lr 3/13/2010 12:09'!
isActive
	^ (requestor isSelected: target) and: [ target isBrowsable ]! !

!OBCmdBrowse methodsFor: 'accessing' stamp: 'cwp 10/9/2006 15:18'!
keystroke
	^ $b! !

!OBCmdBrowse methodsFor: 'accessing' stamp: 'lr 8/8/2010 10:07'!
label
	^ 'Browse'! !

!OBCmdBrowse methodsFor: 'accessing' stamp: 'dc 8/26/2008 17:40'!
longDescription
	^ 'open a new browser on the current element'! !

!OBCmdBrowse methodsFor: 'testing' stamp: 'cwp 3/11/2007 19:34'!
wantsButton
	^ true! !

OBCommand subclass: #OBCmdBrowseHierarchy
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Alt-Browser-Standard-Commands'!

!OBCmdBrowseHierarchy methodsFor: 'accessing' stamp: 'lr 8/8/2010 10:14'!
buttonLabel
	^ 'Hierarchy'! !

!OBCmdBrowseHierarchy methodsFor: 'execution' stamp: 'lr 4/3/2009 13:44'!
execute
	target browseHierarchy! !

!OBCmdBrowseHierarchy methodsFor: 'accessing' stamp: 'cwp 10/11/2006 00:17'!
group
	^ #navigation! !

!OBCmdBrowseHierarchy methodsFor: 'testing' stamp: 'ThierryGoubier 7/16/2012 16:17'!
isActive
	^ (requestor isSelected: target) and: [ (target isKindOf: ABClassNode) and: [ target theClass isTrait not ] ]! !

!OBCmdBrowseHierarchy methodsFor: 'accessing' stamp: 'dc. 12/15/2007 15:46'!
keystroke
	^ $h! !

!OBCmdBrowseHierarchy methodsFor: 'accessing' stamp: 'lr 8/8/2010 10:07'!
label
	^ 'Browse hierarchy'! !

!OBCmdBrowseHierarchy methodsFor: 'accessing' stamp: 'dc 8/26/2008 17:49'!
longDescription
  ^ 'browse the hierarchy of the class'! !

!OBCmdBrowseHierarchy methodsFor: 'testing' stamp: 'ThierryGoubier 7/16/2012 16:40'!
wantsButton
	"^ (target isKindOf: OBMethodVersionNode) not"! !

OBCommand subclass: #OBCmdBrowseImplementorsOfIt
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Alt-Browser-Standard-Commands'!

!OBCmdBrowseImplementorsOfIt class methodsFor: 'testing' stamp: 'cwp 10/16/2006 22:13'!
takesNodes
	^ false! !

!OBCmdBrowseImplementorsOfIt class methodsFor: 'testing' stamp: 'cwp 10/16/2006 22:01'!
takesText
	^ true! !

!OBCmdBrowseImplementorsOfIt methodsFor: 'execution' stamp: 'ThierryGoubier 7/16/2012 16:44'!
execute
	self halt"| node |
	node := OBSelectorNode on: target selector.
	(requestor announce: (OBShowImplementors of: node)) execute"! !

!OBCmdBrowseImplementorsOfIt methodsFor: 'testing' stamp: 'cwp 10/16/2006 21:32'!
isActive
	^ true! !

!OBCmdBrowseImplementorsOfIt methodsFor: 'testing' stamp: 'cwp 10/16/2006 23:14'!
isEnabled
	^ target hasSelector! !

!OBCmdBrowseImplementorsOfIt methodsFor: 'accessing' stamp: 'cwp 3/11/2007 19:53'!
keystroke
	^ $m! !

!OBCmdBrowseImplementorsOfIt methodsFor: 'accessing' stamp: 'lr 8/8/2010 10:07'!
label
	^ 'Implementors'! !

OBCommand subclass: #OBCmdBrowseInheritance
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Alt-Browser-Standard-Commands'!

!OBCmdBrowseInheritance methodsFor: 'execution' stamp: 'ThierryGoubier 7/16/2012 16:31'!
execute
	"OBInheritanceBrowser openRoot: target inheritanceRoot selection: target"! !

!OBCmdBrowseInheritance methodsFor: 'accessing' stamp: 'cwp 10/17/2006 21:30'!
group
	^ #navigation! !

!OBCmdBrowseInheritance methodsFor: 'testing' stamp: 'lr 3/13/2010 17:05'!
isActive
	^ (requestor isSelected: target) and: [ target hasSelector ]! !

!OBCmdBrowseInheritance methodsFor: 'accessing' stamp: 'lr 8/8/2010 10:07'!
label
	^ 'Inheritance'! !

!OBCmdBrowseInheritance methodsFor: 'testing' stamp: 'ThierryGoubier 7/16/2012 16:40'!
wantsButton
	"^ (target isKindOf: OBMethodVersionNode) not"! !

OBCommand subclass: #OBCmdBrowseList
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Alt-Browser-Standard-Commands'!

OBCmdBrowseList subclass: #OBCmdBrowseHierarchyImplementors
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Alt-Browser-Standard-Commands'!

!OBCmdBrowseHierarchyImplementors methodsFor: 'configuration' stamp: 'dr 9/21/2007 11:22'!
announcementClass
	^ OBShowHierarchyImplementors! !

!OBCmdBrowseHierarchyImplementors methodsFor: 'command' stamp: 'lr 9/1/2011 21:28'!
label
	^ 'Implementors in hierarchy...'! !

OBCmdBrowseList subclass: #OBCmdBrowseHierarchySenders
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Alt-Browser-Standard-Commands'!

!OBCmdBrowseHierarchySenders methodsFor: 'configuration' stamp: 'dr 9/21/2007 11:22'!
announcementClass
	^ OBShowHierarchySenders! !

!OBCmdBrowseHierarchySenders methodsFor: 'command' stamp: 'lr 9/1/2011 21:28'!
label
	^ 'Senders in hierarchy...'! !

OBCmdBrowseList subclass: #OBCmdBrowseImplementors
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Alt-Browser-Standard-Commands'!

!OBCmdBrowseImplementors methodsFor: 'configuration' stamp: 'cwp 8/20/2007 23:00'!
announcementClass
	^ OBShowImplementors! !

!OBCmdBrowseImplementors methodsFor: 'accessing' stamp: 'cwp 10/15/2006 21:13'!
keystroke
	^ $m! !

!OBCmdBrowseImplementors methodsFor: 'accessing' stamp: 'ThierryGoubier 7/16/2012 16:31'!
label
	^ "(requestor isKindOf: OBFixedButtonPanel)
		ifTrue: [ 'Implementors' ]
		ifFalse: [" 'Implementors...' "]"! !

!OBCmdBrowseImplementors methodsFor: 'accessing' stamp: 'dc 8/26/2008 17:50'!
longDescription
  ^ 'browse implementors of...'! !

!OBCmdBrowseImplementors methodsFor: 'testing' stamp: 'ThierryGoubier 7/16/2012 16:40'!
wantsButton
	"^ (target isKindOf: OBMethodVersionNode) not"! !

!OBCmdBrowseList class methodsFor: 'utilties' stamp: 'lr 9/1/2011 21:32'!
selectSymbol: aString default: aSymbol proposed: anArray
	| systemSymbols |
	^ OBCompletionRequest new
		prompt: aString;
		default: aSymbol;
		searchBlock: [ :value |
			(systemSymbols isNil and: [ aSymbol ~= value ]) ifTrue: [
				systemSymbols := IdentitySet new.
				Smalltalk globals allClassesAndTraitsDo: [ :each | 
					systemSymbols
						addAll: each selectors;
						addAll: each class selectors ].
				systemSymbols := systemSymbols sorted ].
			(systemSymbols isNil or: [ value isEmpty ])
				ifTrue: [ anArray ]
				ifFalse: [ systemSymbols select: [ :each | OBCompletionRequest subsequence: value matches: each caseSensitive: false ] ] ];
		signal.! !

!OBCmdBrowseList methodsFor: 'accessing' stamp: 'lr 3/4/2009 22:07'!
announcementClass
	self subclassResponsibility! !

!OBCmdBrowseList methodsFor: 'command' stamp: 'ThierryGoubier 7/16/2012 16:34'!
execute
	| localSymbols systemSymbols symbol node |
	localSymbols := target selectorAndMessages
		collect: [ :each | each name ].
	symbol := self class
		selectSymbol: 'Choose ' , (self label allButLast: 4)
		default: localSymbols first
		proposed: localSymbols.
	symbol ifNil: [ ^ self ].
	"node := ABMessageNode
		on: symbol asSymbol
		inMethod: symbol asSymbol
		inClass: target theClass."
	(requestor announce: (self announcementClass of: node))
		execute! !

!OBCmdBrowseList methodsFor: 'command' stamp: 'dr 7/2/2007 15:12'!
group
	^ #navigation! !

!OBCmdBrowseList methodsFor: 'command' stamp: 'lr 3/13/2010 17:05'!
isActive
	^ (requestor isSelected: target) and: [ target hasSelector ]! !

OBCmdBrowseList subclass: #OBCmdBrowseSenders
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Alt-Browser-Standard-Commands'!

!OBCmdBrowseSenders methodsFor: 'configuration' stamp: 'cwp 8/20/2007 23:00'!
announcementClass
	^ OBShowSenders! !

!OBCmdBrowseSenders methodsFor: 'command' stamp: 'cwp 10/11/2006 20:35'!
keystroke
	^ $n! !

!OBCmdBrowseSenders methodsFor: 'accessing' stamp: 'ThierryGoubier 7/16/2012 16:31'!
label
	^" (requestor isKindOf: OBFixedButtonPanel)
		ifTrue: [ 'Senders' ]
		ifFalse: [" 'Senders...' "]"! !

!OBCmdBrowseSenders methodsFor: 'accessing' stamp: 'dc 8/26/2008 17:52'!
longDescription
  ^ 'browse senders of...'! !

!OBCmdBrowseSenders methodsFor: 'testing' stamp: 'cwp 7/7/2007 21:03'!
wantsButton
	^ true! !

OBCommand subclass: #OBCmdBrowseMethodVersions
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Alt-Browser-Standard-Commands'!

!OBCmdBrowseMethodVersions methodsFor: 'execution' stamp: 'ThierryGoubier 7/16/2012 16:51'!
execute
	self halt"OBVersionBrowser openOn: target copy"! !

!OBCmdBrowseMethodVersions methodsFor: 'accessing' stamp: 'cwp 10/9/2006 18:09'!
group
	^ #navigation! !

!OBCmdBrowseMethodVersions methodsFor: 'testing' stamp: 'lr 3/13/2010 17:05'!
isActive
	^ (requestor isSelected: target) and: [ target hasVersions ]! !

!OBCmdBrowseMethodVersions methodsFor: 'accessing' stamp: 'cwp 3/11/2007 19:53'!
keystroke
	^ $v! !

!OBCmdBrowseMethodVersions methodsFor: 'accessing' stamp: 'lr 8/8/2010 10:07'!
label
	^ 'Versions'! !

!OBCmdBrowseMethodVersions methodsFor: 'accessing' stamp: 'dc 8/26/2008 17:51'!
longDescription
  ^ 'display the different versions of this method'! !

!OBCmdBrowseMethodVersions methodsFor: 'testing' stamp: 'ThierryGoubier 7/16/2012 16:40'!
wantsButton
	"^ (target isKindOf: OBMethodVersionNode) not"! !

OBCommand subclass: #OBCmdBrowseReferences
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Alt-Browser-Standard-Commands'!

!OBCmdBrowseReferences methodsFor: 'execution' stamp: 'ThierryGoubier 7/16/2012 16:42'!
execute
	self halt"OBReferencesBrowser browseRoot: target theNonMetaClass asNode"! !

!OBCmdBrowseReferences methodsFor: 'accessing' stamp: 'cwp 12/7/2006 22:30'!
group
	^ #navigation! !

!OBCmdBrowseReferences methodsFor: 'testing' stamp: 'ThierryGoubier 7/16/2012 16:17'!
isActive
	^ (target isKindOf: ABClassNode)
		and: [requestor isSelected: target]! !

!OBCmdBrowseReferences methodsFor: 'accessing' stamp: 'ben 8/3/2007 12:12'!
keystroke
	^ $N! !

!OBCmdBrowseReferences methodsFor: 'accessing' stamp: 'lr 8/8/2010 10:07'!
label
	^ 'Browse references'! !

OBCommand subclass: #OBCmdBrowseReferencesOfIt
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Alt-Browser-Standard-Commands'!

!OBCmdBrowseReferencesOfIt class methodsFor: 'testing' stamp: 'lr 8/16/2010 10:44'!
takesNodes
	^ false! !

!OBCmdBrowseReferencesOfIt class methodsFor: 'testing' stamp: 'lr 8/16/2010 10:44'!
takesText
	^ true! !

!OBCmdBrowseReferencesOfIt methodsFor: 'execution' stamp: 'ThierryGoubier 7/16/2012 16:42'!
execute
	self halt"self globalReference
		ifNotNil: [ :node | ^ OBReferencesBrowser browseRoot: node ].
	self localReference
		ifNotNil: [ :node | ^ (OBVariablesBrowser browseRoot: node theClass asNode) jumpTo: node ]"! !

!OBCmdBrowseReferencesOfIt methodsFor: 'private' stamp: 'lr 7/13/2011 09:29'!
globalReference
	| binding |
	target hasSelector
		ifFalse: [ ^ nil ].
	((binding := Smalltalk classNamed: target selector) notNil and: [ binding value notNil ])
		ifTrue: [ ^ binding value asNode ].
	^ nil
! !

!OBCmdBrowseReferencesOfIt methodsFor: 'testing' stamp: 'lr 8/16/2010 10:44'!
isActive
	^ true! !

!OBCmdBrowseReferencesOfIt methodsFor: 'testing' stamp: 'lr 4/9/2011 17:48'!
isEnabled
	^ self globalReference notNil or: [ self localReference notNil ]! !

!OBCmdBrowseReferencesOfIt methodsFor: 'accessing' stamp: 'lr 8/16/2010 10:44'!
keystroke
	^ $N! !

!OBCmdBrowseReferencesOfIt methodsFor: 'accessing' stamp: 'lr 8/16/2010 11:09'!
label
	^ 'References'! !

!OBCmdBrowseReferencesOfIt methodsFor: 'private' stamp: 'ThierryGoubier 7/16/2012 16:29'!
localReference
	| class |
	target hasSelector
		ifFalse: [ ^ nil ].
	requestor selectedClass isNil
		ifTrue: [ ^ nil ].
	" look for an instance variable: "
	class := requestor selectedClass whichClassDefinesInstVar: target selector.
	"class isNil
		ifFalse: [ ^ OBInstanceVariableNode on: target selector inClass: class ]."
	" look for a class variable: "
	class := requestor selectedClass whichClassDefinesClassVar: target selector.
	"class isNil
		ifFalse: [ ^ OBClassVariableNode on: target selector inClass: class ]."
	^ nil! !

OBCommand subclass: #OBCmdBrowseSendersOfIt
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Alt-Browser-Standard-Commands'!

!OBCmdBrowseSendersOfIt class methodsFor: 'testing' stamp: 'cwp 10/15/2006 01:00'!
takesNodes
	^ false! !

!OBCmdBrowseSendersOfIt class methodsFor: 'testing' stamp: 'cwp 10/15/2006 01:00'!
takesText
	^ true! !

!OBCmdBrowseSendersOfIt methodsFor: 'execution' stamp: 'ThierryGoubier 7/16/2012 16:44'!
execute
	self halt"| node |
	node := OBSelectorNode on: target selector.
	(requestor announce: (OBShowSenders of: node)) execute"! !

!OBCmdBrowseSendersOfIt methodsFor: 'testing' stamp: 'cwp 10/14/2006 21:06'!
isActive
	^ true! !

!OBCmdBrowseSendersOfIt methodsFor: 'testing' stamp: 'cwp 10/15/2006 19:31'!
isEnabled
	^ target hasSelector! !

!OBCmdBrowseSendersOfIt methodsFor: 'accessing' stamp: 'cwp 3/11/2007 19:57'!
keystroke
	^ $n! !

!OBCmdBrowseSendersOfIt methodsFor: 'accessing' stamp: 'lr 8/8/2010 10:07'!
label
	^ 'Senders'! !

OBCommand subclass: #OBCmdChaseVariables
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Alt-Browser-Standard-Commands'!

!OBCmdChaseVariables methodsFor: 'accessing' stamp: 'lr 8/8/2010 10:14'!
buttonLabel
	^ 'Variables'! !

!OBCmdChaseVariables methodsFor: 'execution' stamp: 'ThierryGoubier 7/16/2012 16:50'!
execute
	self halt"^ OBVariablesBrowser browseRoot: target classNode"! !

!OBCmdChaseVariables methodsFor: 'accessing' stamp: 'cwp 10/10/2006 22:50'!
group
	^ #navigation! !

!OBCmdChaseVariables methodsFor: 'testing' stamp: 'ThierryGoubier 7/16/2012 16:18'!
isActive
	^ ((target isKindOf: ABClassNode) or: [(target respondsTo: #theClass) and: [target theClass notNil]])
		and: [requestor isSelected: target]! !

!OBCmdChaseVariables methodsFor: 'accessing' stamp: 'lr 8/8/2010 10:07'!
label
	^ 'Chase variables'! !

!OBCmdChaseVariables methodsFor: 'testing' stamp: 'ThierryGoubier 7/16/2012 16:40'!
wantsButton
	"^ (target isKindOf: OBMethodVersionNode) not"! !

OBCommand subclass: #OBCmdClassTemplate
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Alt-Browser-Standard-Commands'!

!OBCmdClassTemplate methodsFor: 'accessing' stamp: 'dc 7/16/2007 18:34'!
currentCategory
	^ target theNonMetaClass category! !

!OBCmdClassTemplate methodsFor: 'accessing' stamp: 'dc 7/16/2007 18:36'!
currentClass
	^ target theNonMetaClass! !

!OBCmdClassTemplate methodsFor: 'accessing' stamp: 'dc 7/16/2007 18:34'!
currentEnvironment
	^ target theNonMetaClass environment! !

!OBCmdClassTemplate methodsFor: 'execution' stamp: 'lr 3/4/2009 08:17'!
execute
	| definition |
	definition := self templateDefinition.
	definition isNil ifFalse: [ requestor announce: (OBDefinitionChanged definition: definition) ]! !

!OBCmdClassTemplate methodsFor: 'accessing' stamp: 'lr 5/9/2011 18:49'!
icon
	^ #newIcon! !

!OBCmdClassTemplate methodsFor: 'testing' stamp: 'ThierryGoubier 7/16/2012 16:27'!
isActive
	^ (target isKindOf: ABClassNode)
		and: [requestor isSelected: target]! !

!OBCmdClassTemplate methodsFor: 'private' stamp: 'dc 7/16/2007 18:42'!
templateDefinition
	self subclassResponsibility! !

OBCmdClassTemplate subclass: #OBCmdNewClassTemplate
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Alt-Browser-Standard-Commands'!

!OBCmdNewClassTemplate methodsFor: 'execution' stamp: 'dc 4/23/2007 15:08'!
execute
	| class definition |
	class := target theNonMetaClass.
	definition := (OBClassDefinition 
					environment: class environment 
					template: (Class template: class category)).
	requestor announce: (OBDefinitionChanged definition: definition)! !

!OBCmdNewClassTemplate methodsFor: 'accessing' stamp: 'lr 8/8/2010 10:07'!
label
	^ 'New class template'! !

!OBCmdNewClassTemplate methodsFor: 'private' stamp: 'dc 7/16/2007 18:42'!
templateDefinition
	^ OBClassDefinition environment: self currentEnvironment
		template: (Class template: self currentCategory)! !

OBCmdClassTemplate subclass: #OBCmdSubclassTemplate
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Alt-Browser-Standard-Commands'!

!OBCmdSubclassTemplate methodsFor: 'accessing' stamp: 'lr 8/8/2010 10:07'!
label
	^ 'Subclass template'! !

!OBCmdSubclassTemplate methodsFor: 'private' stamp: 'dc 7/16/2007 18:42'!
templateDefinition
	^ OBClassDefinition environment: self currentEnvironment
		template: (Class templateForSubclassOf: self currentClass
				category: self currentCategory)! !

OBCommand subclass: #OBCmdCompareToCurrent
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Alt-Browser-Standard-Commands'!

!OBCmdCompareToCurrent methodsFor: 'accessing' stamp: 'lr 8/8/2010 10:14'!
buttonLabel
	^ 'Compare to current'! !

!OBCmdCompareToCurrent methodsFor: 'execution' stamp: 'ThierryGoubier 7/16/2012 16:49'!
execute
	| defPanel s1 s2 text current change |
	defPanel := requestor browser definitionPanel.
	current := target source.
	change := target version source.
	
	s1 := current string.
	s2 := change string.
	s1 = s2
		ifTrue: [^ self inform: 'Exact Match' translated].

	text := TextDiffBuilder
				buildDisplayPatchFrom: s1
				to: s2
				inClass: target theNonMetaClass
				prettyDiffs: false.
"	defPanel definition: (OBTextDefinition text: text)."! !

!OBCmdCompareToCurrent methodsFor: 'testing' stamp: 'ThierryGoubier 7/16/2012 16:41'!
isActive
	^" (target isKindOf: OBMethodVersionNode) and: ["requestor isSelected: target"]"! !

!OBCmdCompareToCurrent methodsFor: 'accessing' stamp: 'dr 12/16/2008 10:28'!
keystroke
	^ $c! !

!OBCmdCompareToCurrent methodsFor: 'accessing' stamp: 'lr 8/8/2010 10:07'!
label
	^ 'Compare to current method'! !

!OBCmdCompareToCurrent methodsFor: 'accessing' stamp: 'dr 12/16/2008 10:29'!
longDescription
	^ 'compare current method version to current selection'! !

!OBCmdCompareToCurrent methodsFor: 'testing' stamp: 'ThierryGoubier 7/16/2012 16:41'!
wantsButton
	"^ target isKindOf: OBMethodVersionNode"! !

OBCommand subclass: #OBCmdCopyClass
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Alt-Browser-Standard-Commands'!

!OBCmdCopyClass methodsFor: 'execution' stamp: 'lr 4/9/2011 18:15'!
copyClass: oldClass as: newName 
	| oldDefinition newDefinition |
	(oldClass environment hasClassNamed: newName) 
		ifTrue: [^ self error: newName , ' already exists'].
	oldDefinition := oldClass definition.
	newDefinition := oldDefinition 
				copyReplaceAll: '#' , oldClass name asString
				with: '#' , newName asString.
	^ Cursor wait showWhile: 
			[| newClass |
			newClass := Compiler evaluate: newDefinition logged: true.
			oldClass class instVarNames
				do: [ :each | newClass class addInstVarNamed: each ].
			newClass copyAllCategoriesFrom: oldClass.
			newClass class copyAllCategoriesFrom: oldClass class.
			newClass]! !

!OBCmdCopyClass methodsFor: 'execution' stamp: 'lr 3/21/2009 20:03'!
execute
	| newName newClass |
	newName := OBTextRequest 
		prompt: 'Please type new class name'
		template: target theNonMetaClassName asString.
	newName isNil ifTrue: [ ^ self ].
	newClass := self 
		copyClass: target theNonMetaClass
		as: newName asSymbol.
	self 
		select: newClass asNode
		with: requestor announcer! !

!OBCmdCopyClass methodsFor: 'accessing' stamp: 'cwp 11/2/2006 22:00'!
group
	^ #identity! !

!OBCmdCopyClass methodsFor: 'testing' stamp: 'ThierryGoubier 7/16/2012 16:27'!
isActive
	^ (target isKindOf: ABClassNode)
		and: [requestor isSelected: target]
		! !

!OBCmdCopyClass methodsFor: 'accessing' stamp: 'lr 8/8/2010 10:07'!
label
	^ 'Copy...'! !

OBCommand subclass: #OBCmdFileOut
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Alt-Browser-Standard-Commands'!

!OBCmdFileOut methodsFor: 'execution' stamp: 'cwp 10/15/2006 18:50'!
execute
	target fileOut! !

!OBCmdFileOut methodsFor: 'testing' stamp: 'cwp 10/9/2006 15:43'!
isActive
	^ (requestor isSelected: target) 
		and: [target respondsTo: #fileOut]! !

!OBCmdFileOut methodsFor: 'accessing' stamp: 'dr 7/16/2008 11:13'!
keystroke
	^ $o! !

!OBCmdFileOut methodsFor: 'accessing' stamp: 'lr 8/8/2010 10:07'!
label
	^ 'File out'! !

OBCommand subclass: #OBCmdFindClass
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Alt-Browser-Standard-Commands'!

!OBCmdFindClass methodsFor: 'execution' stamp: 'lr 9/22/2010 13:01'!
execute
	| class |
	class := self requestClassToUser.
	class isNil ifFalse: [ 
		self 
			select: class asNode
			with: requestor announcer ]! !

!OBCmdFindClass methodsFor: 'private' stamp: 'lr 4/8/2011 19:39'!
findClassIn: anEnvironment pattern: aString
	^ (anEnvironment classNames
		select: [ :each | OBCompletionRequest subsequence: aString matches: each caseSensitive: false ])
		asSortedCollection collect: [ :each | anEnvironment at: each ]! !

!OBCmdFindClass methodsFor: 'accessing' stamp: 'lr 9/22/2010 13:01'!
group
	^ #class! !

!OBCmdFindClass methodsFor: 'accessing' stamp: 'lr 9/22/2010 13:01'!
icon
	^ #findIcon! !

!OBCmdFindClass methodsFor: 'testing' stamp: 'lr 9/22/2010 13:03'!
isActive
	^ target isEnvironmentNode! !

!OBCmdFindClass methodsFor: 'accessing' stamp: 'cwp 10/9/2006 13:39'!
keystroke
	^ $f! !

!OBCmdFindClass methodsFor: 'accessing' stamp: 'lr 8/8/2010 10:07'!
label
	^ 'Find class...'! !

!OBCmdFindClass methodsFor: 'private' stamp: 'lr 9/22/2010 20:12'!
requestClassToUser
	^ OBCompletionRequest new
		prompt: 'Find Class';
		searchBlock: [ :string | self findClassIn: target environment pattern: string ];
		labelBlock: [ :class | class name ];
		iconBlock: [ :class | class browserIcon ];
		signal! !

OBCommand subclass: #OBCmdFindMethod
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Alt-Browser-Standard-Commands'!

!OBCmdFindMethod methodsFor: 'private' stamp: 'lr 4/23/2010 08:37'!
chooseSelector
	| selectors |
	selectors := target theClass selectors asArray sort.
	^ selectors isEmpty ifFalse: [ OBChoiceRequest labels: selectors ]! !

!OBCmdFindMethod methodsFor: 'execution' stamp: 'ThierryGoubier 7/16/2012 16:38'!
execute
	| selection method |
	selection := self chooseSelector.
	selection ifNotNil: 
			[method := ABMethodNode on: selection inClass: target theClass.
			self select: method with: requestor announcer]! !

!OBCmdFindMethod methodsFor: 'accessing' stamp: 'cwp 6/8/2007 20:37'!
icon
	^ #findIcon! !

!OBCmdFindMethod methodsFor: 'testing' stamp: 'ThierryGoubier 7/16/2012 16:28'!
isActive
	^ (target isKindOf: ABClassNode) and: [requestor isSelected: target]! !

!OBCmdFindMethod methodsFor: 'accessing' stamp: 'lr 8/8/2010 10:07'!
label
	^ 'Find method...'! !

OBCommand subclass: #OBCmdMultiView
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Alt-Browser-Standard-Commands'!

!OBCmdMultiView methodsFor: 'accessing' stamp: 'lr 1/28/2010 15:42'!
compiledMethod
	^ target theClass compiledMethodAt: target selector! !

!OBCmdMultiView methodsFor: 'accessing' stamp: 'lr 1/28/2010 15:35'!
definition: aDefinition
	(requestor announce: OBAboutToChange) isVetoed 
		ifFalse: [ requestor announce: (OBDefinitionChanged definition: aDefinition) ]! !

!OBCmdMultiView methodsFor: 'execution' stamp: 'lr 1/28/2010 15:41'!
execute
	| viewType |
	viewType := OBChoiceRequest 
		prompt: nil 
		labels: #('source' 'pretty print' 'decompile' 'byte codes' ) 
		values: #(showSource showPrettyPrint showDecompile showByteCodes).
	viewType isNil
		ifFalse: [ self perform: viewType ]! !

!OBCmdMultiView methodsFor: 'testing' stamp: 'ThierryGoubier 7/16/2012 16:39'!
isActive
	^ (target isKindOf: ABMethodNode) and: [ requestor isSelected: target ] ! !

!OBCmdMultiView methodsFor: 'testing' stamp: 'lr 8/8/2010 10:07'!
label
	^ 'View'! !

!OBCmdMultiView methodsFor: 'accessing' stamp: 'dc 8/26/2008 17:54'!
longDescription
	^ 'display different views of the current method'! !

!OBCmdMultiView methodsFor: 'actions' stamp: 'ThierryGoubier 7/16/2012 16:49'!
showByteCodes
	self halt
"	self definition: (OBTextDefinition text: self compiledMethod symbolic)"! !

!OBCmdMultiView methodsFor: 'actions' stamp: 'lr 1/28/2010 15:41'!
showDecompile
	self definition: (OBMethodDefinition source: self compiledMethod decompileString inClass: target theClass)! !

!OBCmdMultiView methodsFor: 'actions' stamp: 'lr 1/28/2010 15:41'!
showPrettyPrint
	self definition: (OBMethodDefinition
		source: (target theClass compilerClass 
			format: target source in: target theClass
			notifying: nil) 
		inClass: target theClass)! !

!OBCmdMultiView methodsFor: 'actions' stamp: 'lr 1/28/2010 15:41'!
showSource
	self definition: target definition! !

!OBCmdMultiView methodsFor: 'testing' stamp: 'lr 1/28/2010 15:42'!
wantsButton
	^ true! !

!OBCmdMultiView methodsFor: 'testing' stamp: 'lr 8/8/2010 10:48'!
wantsMenu
	^ false! !

OBCommand subclass: #OBCmdRemoveCat
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Alt-Browser-Standard-Commands'!

!OBCmdRemoveCat methodsFor: 'execution' stamp: 'lr 11/26/2010 00:01'!
execute
	| list choice |
	list := target container organization
		listAtCategoryNamed: target name.
	list isEmpty 
		ifTrue: [ ^ target remove; announceDeletionWith: requestor announcer ].
	choice := OBConfirmationRequest
		prompt: 'Are you sure you want to remove this category and all its elements?'
		confirm: 'Remove'.
	(choice notNil and: [ choice ])
		ifTrue: [ ^ target remove; announceDeletionWith: requestor announcer ]! !

!OBCmdRemoveCat methodsFor: 'accessing' stamp: 'lr 6/9/2007 09:59'!
icon
	^ #deleteIcon! !

!OBCmdRemoveCat methodsFor: 'testing' stamp: 'dr 10/30/2008 09:54'!
isActive
	^ target isCategoryNode and: [requestor isSelected: target]! !

!OBCmdRemoveCat methodsFor: 'accessing' stamp: 'cwp 9/28/2006 08:37'!
keystroke
	^ $x! !

!OBCmdRemoveCat methodsFor: 'accessing' stamp: 'lr 8/8/2010 10:07'!
label
	^ 'Remove category...'! !

OBCommand subclass: #OBCmdRemoveClass
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Alt-Browser-Standard-Commands'!

!OBCmdRemoveClass methodsFor: 'execution' stamp: 'lr 11/25/2010 23:40'!
doRemove
	target theNonMetaClass removeFromSystem.
	target announceDeletionWith: requestor announcer! !

!OBCmdRemoveClass methodsFor: 'execution' stamp: 'lr 11/25/2010 23:55'!
execute
	(OBConfirmationRequest 
		prompt: 'Are you certain that you want to remove the class ' , target theNonMetaClassName , ' from the system?'
		confirm: 'Remove') 
			ifFalse: [ ^ self ].
	self doRemove! !

!OBCmdRemoveClass methodsFor: 'accessing' stamp: 'cwp 11/3/2006 00:15'!
group
	^ #identity! !

!OBCmdRemoveClass methodsFor: 'accessing' stamp: 'cwp 6/8/2007 20:37'!
icon
	^ #deleteIcon! !

!OBCmdRemoveClass methodsFor: 'testing' stamp: 'ThierryGoubier 7/16/2012 16:28'!
isActive
	^ (target isKindOf: ABClassNode) and: [requestor isSelected: target]! !

!OBCmdRemoveClass methodsFor: 'accessing' stamp: 'cwp 11/3/2006 00:17'!
keystroke
	^ $x! !

!OBCmdRemoveClass methodsFor: 'accessing' stamp: 'lr 8/8/2010 10:07'!
label
	^ 'Remove class...'! !

OBCmdRemoveClass subclass: #ORCmdRemoveClass
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Alt-Browser-Refactory-Commands-Replacement'!

!ORCmdRemoveClass methodsFor: 'private' stamp: 'lr 9/8/2011 20:10'!
doRemove
	RBRefactoryChangeManager instance
		performChange: (RBRemoveClassChange 
			remove: target theNonMetaClass).
	requestor announce: (OBNodeDeleted node: target)! !

OBCommand subclass: #OBCmdRemoveElement
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Alt-Browser-Standard-Commands'!

!OBCmdRemoveElement methodsFor: 'execution' stamp: 'cb 7/19/2007 14:49'!
execute

	target removeChild: requestor selectedNode.
	requestor listChanged! !

!OBCmdRemoveElement methodsFor: 'accessing' stamp: 'lr 5/9/2011 18:49'!
icon
	^ #deleteIcon! !

!OBCmdRemoveElement methodsFor: 'testing' stamp: 'ThierryGoubier 7/16/2012 16:30'!
isActive

	^" (target isKindOf: OBCollectionNode) and: ["requestor hasSelection"]"! !

!OBCmdRemoveElement methodsFor: 'accessing' stamp: 'lr 8/8/2010 10:07'!
label
	^ 'Remove element'! !

OBCommand subclass: #OBCmdRemoveMethod
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Alt-Browser-Standard-Commands'!

!OBCmdRemoveMethod methodsFor: 'private' stamp: 'ThierryGoubier 7/16/2012 16:45'!
browseSenders
	self halt"OBSendersBrowser browseRoot: target copy"! !

!OBCmdRemoveMethod methodsFor: 'private' stamp: 'lr 2/7/2010 11:23'!
doRemove
	| methods idxToBeRemoved method |
	methods := OrderedCollection new.
	requestor previous isNil ifFalse: 
		[ | selectedNode |
		selectedNode := requestor previous selectedNode.
		(selectedNode isClassNode or: [ selectedNode isMethodCategoryNode ]) ifTrue: 
			[ methods := selectedNode methods.
			idxToBeRemoved := methods indexOf: target ] ].
	target theClass removeSelector: target selector.
	requestor announce: (OBNodeDeleted node: target).
	methods size > 1 ifFalse: [ ^ self ].
	method := methods 
		at: idxToBeRemoved + 1
		ifAbsent: [ methods at: idxToBeRemoved - 1 ].
	self 
		select: method
		with: requestor announcer! !

!OBCmdRemoveMethod methodsFor: 'execution' stamp: 'lr 3/4/2009 08:17'!
execute
	| senders choice |
	senders := SystemNavigation default allCallsOn: target selector.
	senders isEmpty ifTrue: [ ^ self doRemove ].
	choice := OBChoiceRequest 
		prompt: 'This message has ' , senders size asString , ' senders.'
		labels: #(
				'Remove it'
				'Remove, then browse senders'
				'Don''t remove, but show me those senders'
				'Forget it -- do nothing -- sorry I asked'
			)
		values: #(
				#doRemove
				#removeAndBrowse
				#browseSenders
				nil
			).
	choice isNil ifFalse: [ ^ self perform: choice ]! !

!OBCmdRemoveMethod methodsFor: 'accessing' stamp: 'lr 6/9/2007 09:59'!
icon
	^ #deleteIcon! !

!OBCmdRemoveMethod methodsFor: 'testing' stamp: 'ThierryGoubier 7/16/2012 16:39'!
isActive
	^ (target isKindOf: ABMethodNode) and: [requestor isSelected: target]! !

!OBCmdRemoveMethod methodsFor: 'accessing' stamp: 'cwp 12/8/2006 23:18'!
keystroke
	^ $x! !

!OBCmdRemoveMethod methodsFor: 'accessing' stamp: 'lr 8/8/2010 10:07'!
label
	^ 'Remove method...'! !

!OBCmdRemoveMethod methodsFor: 'private' stamp: 'cwp 12/9/2006 20:37'!
removeAndBrowse
	self browseSenders.
	self doRemove! !

OBCmdRemoveMethod subclass: #ORCmdRemoveMethod
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Alt-Browser-Refactory-Commands-Replacement'!

!ORCmdRemoveMethod methodsFor: 'private' stamp: 'lr 9/8/2011 20:10'!
doRemove
	RBRefactoryChangeManager instance
		performChange: (RBRemoveMethodChange 
			remove: target selector from: target theClass).
	requestor announce: (OBNodeDeleted node: target)! !

OBCommand subclass: #OBCmdRenameClass
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Alt-Browser-Standard-Commands'!

!OBCmdRenameClass methodsFor: 'execution' stamp: 'ThierryGoubier 7/16/2012 16:42'!
browseObsoleteRefs: aClassNode as: oldName 
	| binding |
	binding := aClassNode theNonMetaClass environment 
				associationAt: aClassNode theNonMetaClass name.
	self halt"(SystemNavigation default allCallsOn: binding) isEmpty 
		ifFalse: [OBReferencesBrowser
					browseRoot: aClassNode
					title: 'Obsolete references to']"! !

!OBCmdRenameClass methodsFor: 'private' stamp: 'lr 11/25/2010 23:41'!
doRename: oldName to: newName
	target theNonMetaClass environment
		renameClassNamed: oldName
		as: newName.
	target announceChangedWith: requestor announcer! !

!OBCmdRenameClass methodsFor: 'execution' stamp: 'lr 7/26/2011 08:55'!
execute
	| newName oldName |
	newName := OBTextRequest 
		prompt: 'Please type new class name'
		template: target theNonMetaClassName asString.
	newName isNil ifTrue: [ ^ self ].
	oldName := target theNonMetaClass name.
	self doRename: oldName to: newName asSymbol.
	self browseObsoleteRefs: target copy as: oldName! !

!OBCmdRenameClass methodsFor: 'accessing' stamp: 'cwp 11/2/2006 23:58'!
group
	^ #identity! !

!OBCmdRenameClass methodsFor: 'testing' stamp: 'ThierryGoubier 7/16/2012 16:28'!
isActive
	^ (target isKindOf: ABClassNode)
		and: [requestor isSelected: target]! !

!OBCmdRenameClass methodsFor: 'accessing' stamp: 'lr 8/8/2010 10:07'!
label
	^ 'Rename...'! !

OBCmdRenameClass subclass: #ORCmdRenameClass
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Alt-Browser-Refactory-Commands-Replacement'!

!ORCmdRenameClass methodsFor: 'execution' stamp: 'ThierryGoubier 7/16/2012 16:52'!
execute
	"Delegate the execution to the real refactoring."
	
	self halt"(ORCmdRenameClassRefactoring on: target for: requestor)
		execute"! !

OBCommand subclass: #OBCmdResetSearch
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Alt-Browser-Standard-Commands'!

!OBCmdResetSearch methodsFor: 'execution' stamp: 'lr 8/8/2010 10:53'!
execute
	target setCollection: OrderedCollection new.
	requestor  listChanged.! !

!OBCmdResetSearch methodsFor: 'testing' stamp: 'ThierryGoubier 7/16/2012 16:30'!
isActive

	^ "target isKindOf: OBCollectionNode" true! !

!OBCmdResetSearch methodsFor: 'accessing' stamp: 'lr 8/8/2010 10:07'!
label
	^ 'Reset list'! !

OBCommand subclass: #OBCmdRevertMethod
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Alt-Browser-Standard-Commands'!

!OBCmdRevertMethod methodsFor: 'accessing' stamp: 'lr 8/8/2010 10:14'!
buttonLabel
	^ 'Revert'! !

!OBCmdRevertMethod methodsFor: 'execution' stamp: 'lr 3/12/2010 10:32'!
execute
	target version fileIn: target theClass! !

!OBCmdRevertMethod methodsFor: 'testing' stamp: 'ThierryGoubier 7/16/2012 16:41'!
isActive
	^" (target isKindOf: OBMethodVersionNode) and: ["requestor isSelected: target"]"! !

!OBCmdRevertMethod methodsFor: 'accessing' stamp: 'cwp 10/9/2006 18:26'!
keystroke
	^ $r! !

!OBCmdRevertMethod methodsFor: 'accessing' stamp: 'lr 8/8/2010 10:07'!
label
	^ 'Revert to version'! !

!OBCmdRevertMethod methodsFor: 'accessing' stamp: 'dc 8/26/2008 17:56'!
longDescription
	^ 'reverts the method to the current selection'! !

!OBCmdRevertMethod methodsFor: 'testing' stamp: 'ThierryGoubier 7/16/2012 16:41'!
wantsButton
	"^ target isKindOf: OBMethodVersionNode"! !

OBCommand subclass: #OBCmdSelectMethodCategory
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Alt-Browser-Standard-Commands'!

!OBCmdSelectMethodCategory methodsFor: 'execution' stamp: 'ThierryGoubier 7/16/2012 16:15'!
execute

	self 
					select: (ABMethodCategoryNode 
						on: (target theClass organization categoryOfElement: target selector)
						inClass: target theClass)
					with: requestor announcer.
	self select: target with: requestor announcer! !

!OBCmdSelectMethodCategory methodsFor: 'testing' stamp: 'ThierryGoubier 7/16/2012 16:39'!
isActive
	^ (target isKindOf: ABMethodNode)
		and: [requestor isSelected: target]! !

!OBCmdSelectMethodCategory methodsFor: 'accessing' stamp: 'dc. 12/15/2007 15:36'!
keystroke
	^ $C! !

!OBCmdSelectMethodCategory methodsFor: 'accessing' stamp: 'lr 8/8/2010 10:07'!
label
	^ 'Toggle all/category'! !

!OBCommand classSide methodsFor: 'instance creation' stamp: 'cwp 10/14/2006 23:29'!
on: target for: requestor
	^ self new setTarget: target requestor: requestor! !

!OBCommand classSide methodsFor: 'testing' stamp: 'cwp 10/15/2006 00:58'!
takesNodes
	^ true! !

!OBCommand classSide methodsFor: 'testing' stamp: 'cwp 10/15/2006 00:58'!
takesText
	^ false! !

!OBCommand methodsFor: 'user interface' stamp: 'lr 4/25/2011 11:07'!
addItemToMenu: aMenu
	self isActive ifTrue: [
		aMenu
			add: self label
			target: self 
			selector: #execute
			enabled: self isEnabled
			icon: self icon
			keystroke: self keystroke ]! !

!OBCommand methodsFor: 'accessing' stamp: 'lr 4/25/2007 09:27'!
buttonLabel
	^ self label! !

!OBCommand methodsFor: 'accessing' stamp: 'cwp 9/30/2007 18:59'!
cluster
	^ nil! !

!OBCommand methodsFor: 'accessing' stamp: 'cwp 9/30/2007 20:18'!
createCluster
	^ OBCommandCluster label: self cluster! !

!OBCommand methodsFor: 'execution' stamp: 'cwp 10/15/2006 14:12'!
execute
	! !

!OBCommand methodsFor: 'accessing' stamp: 'cwp 10/6/2006 21:44'!
group
	^ #general! !

!OBCommand methodsFor: 'accessing' stamp: 'cwp 10/6/2006 18:45'!
icon
	^ nil! !

!OBCommand methodsFor: 'testing' stamp: 'cwp 10/15/2006 22:05'!
isActive
	^ false! !

!OBCommand methodsFor: 'testing' stamp: 'cwp 10/15/2006 19:31'!
isEnabled
	^ true! !

!OBCommand methodsFor: 'accessing' stamp: 'cwp 9/27/2006 22:53'!
keystroke
	^ nil
! !

!OBCommand methodsFor: 'accessing' stamp: 'cwp 9/27/2006 22:53'!
label
	self subclassResponsibility
! !

!OBCommand methodsFor: 'accessing' stamp: 'dc 8/3/2007 12:50'!
longDescription
	"Override this and return a string or a text for the fly-by-help (tooltip)"
	^ nil! !

!OBCommand methodsFor: 'accessing' stamp: 'lr 9/24/2010 21:46'!
longLabel
	^ self cluster isNil
		ifTrue: [ self label ]
		ifFalse: [ self cluster , ' > ' , self label ]! !

!OBCommand methodsFor: 'accessing' stamp: 'cwp 10/14/2006 23:39'!
on: anObject for: aRequestor
	^ self class on: anObject for: aRequestor! !

!OBCommand methodsFor: 'user interface' stamp: 'dc 1/3/2008 10:11'!
order
	^ self label! !

!OBCommand methodsFor: 'user interface' stamp: 'cwp 10/15/2006 12:37'!
perform: aSelector orSendTo: anObject
	self perform: aSelector! !

!OBCommand methodsFor: 'user interface' stamp: 'lr 11/25/2010 23:45'!
select: aNode with: anAnnouncer
	aNode announceSelectionWith: anAnnouncer! !

!OBCommand methodsFor: 'initialize-release' stamp: 'lr 7/3/2009 22:27'!
setTarget: anObject requestor: aRequestor 
	target := anObject.
	requestor := aRequestor! !

!OBCommand methodsFor: 'testing' stamp: 'lr 2/7/2010 12:50'!
takesNodes
	^ self class takesNodes! !

!OBCommand methodsFor: 'testing' stamp: 'lr 2/7/2010 12:50'!
takesText
	^ self class takesText! !

!OBCommand methodsFor: 'testing' stamp: 'cwp 9/27/2006 22:53'!
wantsButton
	"Put this here for compatibility. Eventually this will be obsolete"

	^ false
! !

!OBCommand methodsFor: 'testing' stamp: 'lr 8/8/2010 10:47'!
wantsMenu
	"Put this here for compatibility. Eventually this will be obsolete"

	^ true
! !

OBCommand subclass: #OBCopyTextCommand
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Alt-Browser-Commands'!

!OBCopyTextCommand classSide methodsFor: 'testing' stamp: 'lr 12/10/2010 09:25'!
takesNodes
	^ false! !

!OBCopyTextCommand classSide methodsFor: 'testing' stamp: 'lr 12/10/2010 09:25'!
takesText
	^ true! !

!OBCopyTextCommand methodsFor: 'execution' stamp: 'lr 12/10/2010 10:40'!
execute
	target copySelection! !

!OBCopyTextCommand methodsFor: 'accessing' stamp: 'lr 12/10/2010 10:37'!
group
	^ #clipboard! !

!OBCopyTextCommand methodsFor: 'accessing' stamp: 'lr 5/9/2011 18:51'!
icon
	^ #copyIcon! !

!OBCopyTextCommand methodsFor: 'testing' stamp: 'lr 12/10/2010 09:22'!
isActive
	^ true! !

!OBCopyTextCommand methodsFor: 'accessing' stamp: 'lr 12/10/2010 09:11'!
keystroke
	^ $c! !

!OBCopyTextCommand methodsFor: 'accessing' stamp: 'lr 12/10/2010 09:11'!
label
	^ 'Copy'! !

!OBCopyTextCommand methodsFor: 'accessing' stamp: 'lr 12/10/2010 09:29'!
order
	^ '2'! !

OBCommand subclass: #OBCutTextCommand
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Alt-Browser-Commands'!

!OBCutTextCommand classSide methodsFor: 'testing' stamp: 'lr 12/10/2010 09:25'!
takesNodes
	^ false! !

!OBCutTextCommand classSide methodsFor: 'testing' stamp: 'lr 12/10/2010 09:25'!
takesText
	^ true! !

!OBCutTextCommand methodsFor: 'execution' stamp: 'lr 3/6/2011 15:03'!
execute
	target cut! !

!OBCutTextCommand methodsFor: 'accessing' stamp: 'lr 12/10/2010 09:27'!
group
	^ #clipboard! !

!OBCutTextCommand methodsFor: 'accessing' stamp: 'lr 5/9/2011 18:51'!
icon
	^ #cutIcon! !

!OBCutTextCommand methodsFor: 'testing' stamp: 'lr 12/10/2010 09:22'!
isActive
	^ true! !

!OBCutTextCommand methodsFor: 'accessing' stamp: 'lr 12/10/2010 09:12'!
keystroke
	^ $x! !

!OBCutTextCommand methodsFor: 'accessing' stamp: 'lr 12/10/2010 09:12'!
label
	^ 'Cut'! !

!OBCutTextCommand methodsFor: 'accessing' stamp: 'lr 12/10/2010 09:29'!
order
	^ '1'! !

OBCommand subclass: #OBDebugItTextCommand
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Alt-Browser-Commands'!

!OBDebugItTextCommand classSide methodsFor: 'testing' stamp: 'lr 8/27/2011 10:02'!
takesNodes
	^ false! !

!OBDebugItTextCommand classSide methodsFor: 'testing' stamp: 'lr 8/27/2011 10:02'!
takesText
	^ true! !

!OBDebugItTextCommand methodsFor: 'execution' stamp: 'lr 8/27/2011 09:58'!
execute
	target debugIt! !

!OBDebugItTextCommand methodsFor: 'accessing' stamp: 'lr 8/27/2011 09:58'!
group
	^ #smalltalk! !

!OBDebugItTextCommand methodsFor: 'accessing' stamp: 'lr 8/27/2011 09:58'!
icon
	^ #debugIcon! !

!OBDebugItTextCommand methodsFor: 'testing' stamp: 'lr 8/27/2011 09:58'!
isActive
	^ true! !

!OBDebugItTextCommand methodsFor: 'accessing' stamp: 'lr 8/27/2011 09:58'!
keystroke
	^ $D! !

!OBDebugItTextCommand methodsFor: 'accessing' stamp: 'lr 8/27/2011 09:58'!
label
	^ 'Debug it'! !

!OBDebugItTextCommand methodsFor: 'accessing' stamp: 'lr 8/27/2011 10:00'!
order
	^ '5'! !

OBCommand subclass: #OBDoItTextCommand
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Alt-Browser-Commands'!

!OBDoItTextCommand classSide methodsFor: 'testing' stamp: 'lr 3/6/2011 14:55'!
takesNodes
	^ false! !

!OBDoItTextCommand classSide methodsFor: 'testing' stamp: 'lr 3/6/2011 14:55'!
takesText
	^ true! !

!OBDoItTextCommand methodsFor: 'execution' stamp: 'lr 3/6/2011 15:13'!
execute
	target doIt! !

!OBDoItTextCommand methodsFor: 'accessing' stamp: 'lr 3/6/2011 14:55'!
group
	^ #smalltalk! !

!OBDoItTextCommand methodsFor: 'accessing' stamp: 'lr 5/9/2011 18:51'!
icon
	^ #doItIcon! !

!OBDoItTextCommand methodsFor: 'testing' stamp: 'lr 3/6/2011 14:55'!
isActive
	^ true! !

!OBDoItTextCommand methodsFor: 'accessing' stamp: 'lr 3/17/2011 21:38'!
keystroke
	^ $d! !

!OBDoItTextCommand methodsFor: 'accessing' stamp: 'lr 3/6/2011 14:55'!
label
	^ 'Do it'! !

!OBDoItTextCommand methodsFor: 'accessing' stamp: 'lr 3/6/2011 14:54'!
order
	^ '1'! !

OBCommand subclass: #OBExploreItTextCommand
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Alt-Browser-Commands'!

!OBExploreItTextCommand classSide methodsFor: 'testing' stamp: 'lr 3/6/2011 15:08'!
takesNodes
	^ false! !

!OBExploreItTextCommand classSide methodsFor: 'testing' stamp: 'lr 3/6/2011 15:08'!
takesText
	^ true! !

!OBExploreItTextCommand methodsFor: 'execution' stamp: 'lr 3/6/2011 15:13'!
execute
	target exploreIt! !

!OBExploreItTextCommand methodsFor: 'accessing' stamp: 'lr 3/6/2011 15:05'!
group
	^ #smalltalk! !

!OBExploreItTextCommand methodsFor: 'testing' stamp: 'lr 3/6/2011 15:05'!
isActive
	^ true! !

!OBExploreItTextCommand methodsFor: 'accessing' stamp: 'lr 3/6/2011 15:05'!
keystroke
	^ $I! !

!OBExploreItTextCommand methodsFor: 'accessing' stamp: 'lr 3/6/2011 15:05'!
label
	^ 'Explore it'! !

!OBExploreItTextCommand methodsFor: 'accessing' stamp: 'lr 3/6/2011 15:05'!
order
	^ '4'! !

OBCommand subclass: #OBInspectItTextCommand
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Alt-Browser-Commands'!

!OBInspectItTextCommand classSide methodsFor: 'testing' stamp: 'lr 3/6/2011 14:55'!
takesNodes
	^ false! !

!OBInspectItTextCommand classSide methodsFor: 'testing' stamp: 'lr 3/6/2011 14:55'!
takesText
	^ true! !

!OBInspectItTextCommand methodsFor: 'execution' stamp: 'lr 3/6/2011 15:13'!
execute
	target inspectIt! !

!OBInspectItTextCommand methodsFor: 'accessing' stamp: 'lr 3/6/2011 14:56'!
group
	^ #smalltalk! !

!OBInspectItTextCommand methodsFor: 'accessing' stamp: 'lr 5/9/2011 18:52'!
icon
	^ #inspectItIcon! !

!OBInspectItTextCommand methodsFor: 'testing' stamp: 'lr 3/6/2011 14:55'!
isActive
	^ true! !

!OBInspectItTextCommand methodsFor: 'accessing' stamp: 'lr 3/17/2011 21:38'!
keystroke
	^ $i! !

!OBInspectItTextCommand methodsFor: 'accessing' stamp: 'lr 3/6/2011 14:56'!
label
	^ 'Inspect it'! !

!OBInspectItTextCommand methodsFor: 'accessing' stamp: 'lr 3/6/2011 14:56'!
order
	^ '3'! !

OBCommand subclass: #OBPasteTextCommand
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Alt-Browser-Commands'!

!OBPasteTextCommand classSide methodsFor: 'testing' stamp: 'lr 12/10/2010 09:25'!
takesNodes
	^ false! !

!OBPasteTextCommand classSide methodsFor: 'testing' stamp: 'lr 12/10/2010 09:25'!
takesText
	^ true! !

!OBPasteTextCommand methodsFor: 'execution' stamp: 'lr 12/10/2010 09:14'!
execute
	target paste! !

!OBPasteTextCommand methodsFor: 'accessing' stamp: 'lr 12/10/2010 09:27'!
group
	^ #clipboard! !

!OBPasteTextCommand methodsFor: 'accessing' stamp: 'lr 5/9/2011 18:52'!
icon
	^ #pasteIcon! !

!OBPasteTextCommand methodsFor: 'testing' stamp: 'lr 12/10/2010 09:22'!
isActive
	^ true! !

!OBPasteTextCommand methodsFor: 'accessing' stamp: 'lr 12/10/2010 09:14'!
keystroke
	^ $v! !

!OBPasteTextCommand methodsFor: 'accessing' stamp: 'lr 12/10/2010 09:14'!
label
	^ 'Paste'! !

!OBPasteTextCommand methodsFor: 'accessing' stamp: 'lr 12/10/2010 09:29'!
order
	^ '3'! !

OBCommand subclass: #OBPrintItTextCommand
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Alt-Browser-Commands'!

!OBPrintItTextCommand classSide methodsFor: 'testing' stamp: 'lr 3/6/2011 14:55'!
takesNodes
	^ false! !

!OBPrintItTextCommand classSide methodsFor: 'testing' stamp: 'lr 3/6/2011 14:55'!
takesText
	^ true! !

!OBPrintItTextCommand methodsFor: 'execution' stamp: 'lr 3/6/2011 15:13'!
execute
	target printIt! !

!OBPrintItTextCommand methodsFor: 'accessing' stamp: 'lr 3/6/2011 14:56'!
group
	^ #smalltalk! !

!OBPrintItTextCommand methodsFor: 'accessing' stamp: 'lr 5/9/2011 18:52'!
icon
	^ #printIcon! !

!OBPrintItTextCommand methodsFor: 'testing' stamp: 'lr 3/6/2011 14:55'!
isActive
	^ true! !

!OBPrintItTextCommand methodsFor: 'accessing' stamp: 'lr 3/6/2011 14:56'!
keystroke
	^ $p! !

!OBPrintItTextCommand methodsFor: 'accessing' stamp: 'lr 3/6/2011 14:56'!
label
	^ 'Print it'! !

!OBPrintItTextCommand methodsFor: 'accessing' stamp: 'lr 3/6/2011 14:56'!
order
	^ '2'! !

OBCommand subclass: #OBRedoTextCommand
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Alt-Browser-Commands'!

!OBRedoTextCommand classSide methodsFor: 'testing' stamp: 'lr 12/10/2010 09:25'!
takesNodes
	^ false! !

!OBRedoTextCommand classSide methodsFor: 'testing' stamp: 'lr 12/10/2010 09:25'!
takesText
	^ true! !

!OBRedoTextCommand methodsFor: 'execution' stamp: 'lr 12/10/2010 09:20'!
execute
	target redo! !

!OBRedoTextCommand methodsFor: 'accessing' stamp: 'lr 12/10/2010 10:38'!
group
	^ #adapting! !

!OBRedoTextCommand methodsFor: 'accessing' stamp: 'lr 5/9/2011 18:52'!
icon
	^ #redoIcon! !

!OBRedoTextCommand methodsFor: 'testing' stamp: 'lr 12/10/2010 09:22'!
isActive
	^ true! !

!OBRedoTextCommand methodsFor: 'accessing' stamp: 'lr 12/10/2010 09:20'!
keystroke
	^ $Z! !

!OBRedoTextCommand methodsFor: 'accessing' stamp: 'lr 12/10/2010 09:20'!
label
	^ 'Redo'! !

OBCommand subclass: #OBUndoTextCommand
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Alt-Browser-Commands'!

!OBUndoTextCommand classSide methodsFor: 'testing' stamp: 'lr 12/10/2010 09:25'!
takesNodes
	^ false! !

!OBUndoTextCommand classSide methodsFor: 'testing' stamp: 'lr 12/10/2010 09:25'!
takesText
	^ true! !

!OBUndoTextCommand methodsFor: 'execution' stamp: 'lr 12/10/2010 09:20'!
execute
	target undo! !

!OBUndoTextCommand methodsFor: 'accessing' stamp: 'lr 12/10/2010 10:38'!
group
	^ #adapting! !

!OBUndoTextCommand methodsFor: 'accessing' stamp: 'lr 5/9/2011 18:52'!
icon
	^ #undoIcon! !

!OBUndoTextCommand methodsFor: 'testing' stamp: 'lr 12/10/2010 09:22'!
isActive
	^ true! !

!OBUndoTextCommand methodsFor: 'accessing' stamp: 'lr 12/10/2010 09:20'!
keystroke
	^ $z! !

!OBUndoTextCommand methodsFor: 'accessing' stamp: 'lr 12/10/2010 09:20'!
label
	^ 'Undo'! !

OBCommand subclass: #ORCommand
	instanceVariableNames: ''
	classVariableNames: 'PromptOnRefactoring'
	poolDictionaries: ''
	category: 'Alt-Browser-Refactory-Commands'!

ORCommand subclass: #ORCmdEnvironment
	instanceVariableNames: ''
	classVariableNames: 'SavedEnvironments'
	poolDictionaries: ''
	category: 'Alt-Browser-Refactory-Commands'!

ORCmdEnvironment subclass: #ORCmdCategoryEnvironment
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Alt-Browser-Refactory-Commands'!

!ORCmdCategoryEnvironment methodsFor: 'accessing' stamp: 'lr 2/9/2008 15:59'!
environment
	^ super environment forCategories: (Array with: target name)! !

!ORCmdCategoryEnvironment methodsFor: 'testing' stamp: 'ThierryGoubier 7/16/2012 16:23'!
isActive
	^ super isActive and: [ target isKindOf: ABClassCategoryNode ]! !

!ORCmdCategoryEnvironment methodsFor: 'accessing' stamp: 'lr 8/8/2010 10:07'!
label
	^ 'Category'! !

ORCmdEnvironment subclass: #ORCmdClassEnvironment
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Alt-Browser-Refactory-Commands'!

!ORCmdClassEnvironment methodsFor: 'accessing' stamp: 'lr 2/9/2008 16:01'!
environment
	^ super environment forClasses: (Array with: target theNonMetaClass)! !

!ORCmdClassEnvironment methodsFor: 'testing' stamp: 'ThierryGoubier 7/16/2012 16:18'!
isActive
	^ super isActive and: [ target isKindOf: ABClassNode ]! !

!ORCmdClassEnvironment methodsFor: 'accessing' stamp: 'lr 8/8/2010 10:07'!
label
	^ 'Class'! !

ORCmdEnvironment subclass: #ORCmdClassHierarchyEnvironment
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Alt-Browser-Refactory-Commands'!

!ORCmdClassHierarchyEnvironment methodsFor: 'accessing' stamp: 'lr 2/10/2008 10:26'!
environment
	| classes |
	classes := Set new
		addAll: target theNonMetaClass withAllSuperclasses;
		addAll: target theNonMetaClass allSubclasses;
		yourself.
	^ (super environment forClasses: classes)
		label: 'Hierarchy of ' , target theNonMetaClassName! !

!ORCmdClassHierarchyEnvironment methodsFor: 'testing' stamp: 'ThierryGoubier 7/16/2012 16:18'!
isActive
	^ super isActive and: [ target isKindOf: ABClassNode ]! !

!ORCmdClassHierarchyEnvironment methodsFor: 'accessing' stamp: 'lr 8/8/2010 10:07'!
label
	^ 'Class hierarchy'! !

ORCmdEnvironment subclass: #ORCmdClassVarRefsEnvironment
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Alt-Browser-Refactory-Commands'!

!ORCmdClassVarRefsEnvironment methodsFor: 'accessing' stamp: 'lr 3/8/2009 19:08'!
environment
	^ super environment classVarRefsTo: (self chooseFrom: self classVariables) in: target theClass! !

!ORCmdClassVarRefsEnvironment methodsFor: 'testing' stamp: 'ThierryGoubier 7/16/2012 16:28'!
isActive
	^ super isActive and: [ (target isKindOf: ABClassNode) "or: [ target isKindOf: OBClassVariableNode ]" ]! !

!ORCmdClassVarRefsEnvironment methodsFor: 'accessing' stamp: 'lr 9/1/2011 21:54'!
label
	^ 'Class variable references...'! !

ORCmdEnvironment subclass: #ORCmdDependenciesEnvironment
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Alt-Browser-Refactory-Commands'!

!ORCmdDependenciesEnvironment methodsFor: 'private' stamp: 'lr 3/16/2009 09:57'!
add: aClass to: anEnvironment
	anEnvironment
		addClass: aClass theNonMetaClass;
		addClass: aClass theMetaClass! !

!ORCmdDependenciesEnvironment methodsFor: 'accessing' stamp: 'lr 9/8/2011 20:32'!
environment
	"Build an environment with all the static dependencies."

	| result parent inside |
	result := RBClassEnvironment new.
	parent := super environment.
	inside := [ :class | 
		(parent definesClass: class)
			and: [ parent includesClass: class ] ].
	parent classesDo: [ :class |
		"(1) super classes"
		(class isMeta not 
			and: [ class superclass notNil
			and: [ (inside value: class superclass) not ] ])
				ifTrue: [ self add: class superclass to: result ] ].
	parent classesAndSelectorsDo: [ :class :selector |
		"(2) extended classes"
		(inside value: class)
			ifFalse: [ self add: class to: result ].
		"(3) referenced classes"
		(class compiledMethodAt: selector) literals allButLast do: [ :literal |
			(literal isVariableBinding and: [ literal value isBehavior and: [ (inside value: literal value) not ] ])
				ifTrue: [ self add: literal value to: result ] ] ].
	^ result label: 'External Dependencies of ' , parent label! !

!ORCmdDependenciesEnvironment methodsFor: 'testing' stamp: 'lr 3/16/2009 09:50'!
isActive
	^ super isActive and: [ self browser environment isSystem not ]! !

!ORCmdDependenciesEnvironment methodsFor: 'accessing' stamp: 'lr 8/8/2010 10:07'!
label
	^ 'Dependencies'! !

!ORCmdEnvironment class methodsFor: 'initialization' stamp: 'lr 4/21/2010 15:08'!
initialize
	SavedEnvironments := SortedCollection sortBlock: [ :a :b | a label < b label ]! !

!ORCmdEnvironment methodsFor: 'accessing' stamp: 'lr 8/8/2010 10:09'!
cluster
	^ #'Refactoring scope'! !

!ORCmdEnvironment methodsFor: 'execution' stamp: 'ThierryGoubier 7/16/2012 16:54'!
execute
	"[ "self openEnvironment: self environment" ] 
		on: ORUICancellationError
		do: [ :err | ^ self ]"! !

!ORCmdEnvironment methodsFor: 'utilities' stamp: 'ThierryGoubier 7/16/2012 16:54'!
selectEnvironment: aString
	| environment |
	environment := OBChoiceRequest 
		prompt: aString
		labels: (SavedEnvironments collect: [ :each | each label ]) 
		values: SavedEnvironments.
"	environment isNil
		ifTrue: [ ORUICancellationError signal ].
"	^ environment! !

!ORCmdEnvironment methodsFor: 'utilities' stamp: 'ThierryGoubier 7/16/2012 16:54'!
selectEnvironments: aString
	| environments |
	environments := OBMultipleChoiceRequest 
		prompt: aString
		labels: (SavedEnvironments collect: [ :each | each label ]) 
		values: SavedEnvironments.
"	(environments isNil or: [ environments isEmpty ])
		ifTrue: [ ORUICancellationError signal ].
"	^ environments! !

ORCmdEnvironment subclass: #ORCmdImplementorEnvironment
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Alt-Browser-Refactory-Commands'!

!ORCmdImplementorEnvironment methodsFor: 'accessing' stamp: 'lr 9/1/2011 21:46'!
environment
	| selectors selector |
	selectors := target hasSelector
		ifTrue: [ target selectorAndMessages collect: [ :each | each name ] ]
		ifFalse: [ target theClass selectors ].
	selectors isEmpty
		ifFalse: [ selector := selectors first ].
	selector := OBCmdBrowseList
		selectSymbol: 'Choose Implementor'
		default: selector proposed: selectors.
	selector isNil
		ifTrue: [ ^ self uiCancellationError ].
	^ super environment
		implementorsOf: selector! !

!ORCmdImplementorEnvironment methodsFor: 'testing' stamp: 'ThierryGoubier 7/16/2012 16:18'!
isActive
	^ super isActive and: [ target isKindOf: ABClassNode ]! !

!ORCmdImplementorEnvironment methodsFor: 'accessing' stamp: 'lr 9/1/2011 21:36'!
label
	^ 'Implementors...'! !

ORCmdEnvironment subclass: #ORCmdInstVarReaderEnvironment
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Alt-Browser-Refactory-Commands'!

!ORCmdInstVarReaderEnvironment methodsFor: 'accessing' stamp: 'lr 2/9/2008 16:36'!
environment
	^ super environment instVarReadersTo: (self chooseFrom: self instanceVariables) in: target theClass! !

!ORCmdInstVarReaderEnvironment methodsFor: 'testing' stamp: 'ThierryGoubier 7/16/2012 16:19'!
isActive
	^ super isActive and: [ (target isKindOf: ABClassNode) "or: [ target isKindOf: ABInstanceVariableNode ]" ]! !

!ORCmdInstVarReaderEnvironment methodsFor: 'accessing' stamp: 'lr 9/1/2011 21:54'!
label
	^ 'Instance variable reader...'! !

ORCmdEnvironment subclass: #ORCmdInstVarRefsEnvironment
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Alt-Browser-Refactory-Commands'!

!ORCmdInstVarRefsEnvironment methodsFor: 'accessing' stamp: 'lr 2/9/2008 16:28'!
environment
	^ super environment instVarRefsTo: (self chooseFrom: self instanceVariables) in: target theClass! !

!ORCmdInstVarRefsEnvironment methodsFor: 'testing' stamp: 'ThierryGoubier 7/16/2012 16:19'!
isActive
	^ super isActive and: [ (target isKindOf: ABClassNode) "or: [ target isKindOf: OBInstanceVariableNode ]" ]! !

!ORCmdInstVarRefsEnvironment methodsFor: 'accessing' stamp: 'lr 9/1/2011 21:54'!
label
	^ 'Instance variable references...'! !

ORCmdEnvironment subclass: #ORCmdInstVarWriterEnvironment
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Alt-Browser-Refactory-Commands'!

!ORCmdInstVarWriterEnvironment methodsFor: 'accessing' stamp: 'lr 2/9/2008 16:28'!
environment
	^ super environment instVarWritersTo: (self chooseFrom: self instanceVariables) in: target theClass! !

!ORCmdInstVarWriterEnvironment methodsFor: 'testing' stamp: 'ThierryGoubier 7/16/2012 16:19'!
isActive
	^ super isActive and: [ (target isKindOf: ABClassNode)" or: [ target isKindOf: OBInstanceVariableNode ]" ]! !

!ORCmdInstVarWriterEnvironment methodsFor: 'accessing' stamp: 'lr 9/1/2011 21:54'!
label
	^ 'Instance variable writer...'! !

ORCmdEnvironment subclass: #ORCmdIntersectionEnvironment
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Alt-Browser-Refactory-Commands'!

!ORCmdIntersectionEnvironment methodsFor: 'accessing' stamp: 'lr 4/21/2010 15:36'!
environment
	^ super environment & (self selectEnvironment: 'Select scope to intersect with:')! !

!ORCmdIntersectionEnvironment methodsFor: 'accessing' stamp: 'lr 4/21/2010 14:57'!
group
	^ #logical! !

!ORCmdIntersectionEnvironment methodsFor: 'testing' stamp: 'lr 4/21/2010 15:34'!
isEnabled
	^ super isEnabled and: [ super environment isSystem not and: [ SavedEnvironments notEmpty ] ]! !

!ORCmdIntersectionEnvironment methodsFor: 'accessing' stamp: 'lr 8/8/2010 10:07'!
label
	^ 'Itersection...'! !

ORCmdEnvironment subclass: #ORCmdManualEnvironment
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Alt-Browser-Refactory-Commands'!

!ORCmdManualEnvironment methodsFor: 'execution' stamp: 'ThierryGoubier 7/16/2012 16:53'!
execute
	"| browser |
	browser := ORSystemBrowser on: self environment.
	browser jumpTo: target.
	browser open"self halt! !

!ORCmdManualEnvironment methodsFor: 'accessing' stamp: 'lr 4/21/2010 15:01'!
group
	^ #abstract! !

!ORCmdManualEnvironment methodsFor: 'accessing' stamp: 'lr 8/8/2010 10:07'!
label
	^ 'Manual'! !

ORCmdEnvironment subclass: #ORCmdMatchesEnvironment
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Alt-Browser-Refactory-Commands'!

!ORCmdMatchesEnvironment methodsFor: 'accessing' stamp: 'lr 11/11/2008 13:34'!
environment
	| literal |
	literal := self request: 'Literals matching:'.
	^ (super environment matches: literal) 
		label: 'Literals matching ' , literal printString;
		yourself! !

!ORCmdMatchesEnvironment methodsFor: 'accessing' stamp: 'lr 8/8/2010 10:07'!
label
	^ 'Literal matches...'! !

ORCmdEnvironment subclass: #ORCmdNegationEnvironment
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Alt-Browser-Refactory-Commands'!

!ORCmdNegationEnvironment methodsFor: 'accessing' stamp: 'lr 2/9/2008 16:29'!
environment
	^ super environment not! !

!ORCmdNegationEnvironment methodsFor: 'accessing' stamp: 'lr 4/21/2010 14:59'!
group
	^ #logical! !

!ORCmdNegationEnvironment methodsFor: 'testing' stamp: 'lr 4/21/2010 15:15'!
isEnabled
	^ super isEnabled and: [ super environment isSystem not ]! !

!ORCmdNegationEnvironment methodsFor: 'accessing' stamp: 'lr 8/8/2010 10:07'!
label
	^ 'Negation'! !

ORCmdEnvironment subclass: #ORCmdOpenEnvironment
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Alt-Browser-Refactory-Commands'!

!ORCmdOpenEnvironment methodsFor: 'accessing' stamp: 'lr 4/21/2010 15:19'!
environment
	^ self selectEnvironment: 'Select scope to open:'! !

!ORCmdOpenEnvironment methodsFor: 'accessing' stamp: 'lr 4/21/2010 15:11'!
group
	^ #file! !

!ORCmdOpenEnvironment methodsFor: 'testing' stamp: 'lr 4/21/2010 15:16'!
isEnabled
	^ super isEnabled and: [ SavedEnvironments notEmpty ]! !

!ORCmdOpenEnvironment methodsFor: 'accessing' stamp: 'lr 8/8/2010 10:07'!
label
	^ 'Open...'! !

ORCmdEnvironment subclass: #ORCmdPackageEnvironment
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Alt-Browser-Refactory-Commands'!

ORCmdPackageEnvironment subclass: #ORCmdBrowsePackageEnvironment
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Alt-Browser-Refactory-Commands'!

!ORCmdBrowsePackageEnvironment methodsFor: 'accessing' stamp: 'lr 2/10/2008 13:55'!
cluster
	^ nil! !

!ORCmdBrowsePackageEnvironment methodsFor: 'accessing' stamp: 'lr 2/10/2008 13:53'!
group
	^ #navigation! !

!ORCmdBrowsePackageEnvironment methodsFor: 'accessing' stamp: 'lr 10/17/2009 13:45'!
keystroke
	^ $p! !

!ORCmdBrowsePackageEnvironment methodsFor: 'accessing' stamp: 'lr 8/8/2010 10:07'!
label
	^ 'Browse package'! !

!ORCmdPackageEnvironment methodsFor: 'accessing' stamp: 'lr 11/25/2009 09:11'!
environment
	| package |
	^ (super environment forPackages: (Array with: (package := self package))) 
		label: package packageName! !

!ORCmdPackageEnvironment methodsFor: 'testing' stamp: 'lr 1/4/2008 15:53'!
isEnabled
	^ self package notNil! !

!ORCmdPackageEnvironment methodsFor: 'accessing' stamp: 'lr 8/8/2010 10:07'!
label
	^ 'Package'! !

!ORCmdPackageEnvironment methodsFor: 'accessing' stamp: 'lr 9/26/2008 12:16'!
package
	^ target containingPackage! !

ORCmdEnvironment subclass: #ORCmdPragmaEnvironment
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Alt-Browser-Refactory-Commands'!

!ORCmdPragmaEnvironment methodsFor: 'accessing' stamp: 'lr 9/1/2011 21:53'!
environment
	| selectors selector |
	selectors := Set new.
	super environment classesAndSelectorsDo: [ :class :selec |
		(class compiledMethodAt: selec) pragmas
			do: [ :pragma | selectors add: pragma keyword ] ].
	selectors := selectors asSortedCollection.
	selectors isEmpty
		ifFalse: [ selector := selectors first ].
	selector := OBCmdBrowseList
		selectSymbol: 'Choose Sender'
		default: selector proposed: selectors.
	selector isNil
		ifTrue: [ ^ self uiCancellationError ].
	^ (super environment referencesTo: selector)
		label: 'Senders of ' , selector printString;
		yourself! !

!ORCmdPragmaEnvironment methodsFor: 'testing' stamp: 'ThierryGoubier 7/16/2012 16:21'!
isActive
	^ super isActive and: [ target isKindOf: ABClassNode ]! !

!ORCmdPragmaEnvironment methodsFor: 'accessing' stamp: 'lr 9/1/2011 21:49'!
label
	^ 'Pragmas...'! !

ORCmdEnvironment subclass: #ORCmdProtocolEnvironment
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Alt-Browser-Refactory-Commands'!

!ORCmdProtocolEnvironment methodsFor: 'accessing' stamp: 'lr 2/9/2008 16:45'!
environment
	^ super environment forClass: target theClass protocols: (Array with: target name)! !

!ORCmdProtocolEnvironment methodsFor: 'testing' stamp: 'ThierryGoubier 7/16/2012 16:35'!
isActive
	^ super isActive and: [ target isKindOf: ABMethodCategoryNode ]! !

!ORCmdProtocolEnvironment methodsFor: 'accessing' stamp: 'lr 8/8/2010 10:07'!
label
	^ 'Protocol'! !

ORCmdEnvironment subclass: #ORCmdReferencesEnvironment
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Alt-Browser-Refactory-Commands'!

!ORCmdReferencesEnvironment methodsFor: 'accessing' stamp: 'lr 2/10/2008 10:28'!
environment
	^ (super environment referencesTo: target theNonMetaClass binding)
		label: 'References to ' , target theNonMetaClassName! !

!ORCmdReferencesEnvironment methodsFor: 'testing' stamp: 'ThierryGoubier 7/16/2012 16:21'!
isActive
	^ super isActive and: [ target isKindOf: ABClassNode ]! !

!ORCmdReferencesEnvironment methodsFor: 'accessing' stamp: 'lr 8/8/2010 10:07'!
label
	^ 'References'! !

ORCmdEnvironment subclass: #ORCmdRemoveEnvironment
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Alt-Browser-Refactory-Commands'!

!ORCmdRemoveEnvironment methodsFor: 'execution' stamp: 'lr 4/21/2010 15:36'!
execute
	SavedEnvironments removeAll: (self selectEnvironments: 'Select scopes to remove:')  ! !

!ORCmdRemoveEnvironment methodsFor: 'accessing' stamp: 'lr 4/21/2010 15:20'!
group
	^ #file! !

!ORCmdRemoveEnvironment methodsFor: 'testing' stamp: 'lr 4/21/2010 15:20'!
isEnabled
	^ super isEnabled and: [ SavedEnvironments notEmpty ]! !

!ORCmdRemoveEnvironment methodsFor: 'accessing' stamp: 'lr 8/8/2010 10:07'!
label
	^ 'Remove...'! !

ORCmdEnvironment subclass: #ORCmdSaveEnvironment
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Alt-Browser-Refactory-Commands'!

!ORCmdSaveEnvironment methodsFor: 'execution' stamp: 'lr 4/21/2010 15:38'!
execute
	| label |
	label := self 
		prompt: 'Type name of scope:' 
		initialAnswer: self environment label.
	(label isNil or: [ label isEmpty ])
		ifTrue: [ ^ self ].
	SavedEnvironments
		add: (self environment
			label: label;
			yourself)! !

!ORCmdSaveEnvironment methodsFor: 'accessing' stamp: 'lr 4/21/2010 15:11'!
group
	^ #file! !

!ORCmdSaveEnvironment methodsFor: 'testing' stamp: 'lr 4/21/2010 15:34'!
isEnabled
	^ super isEnabled and: [ self environment isSystem not ]! !

!ORCmdSaveEnvironment methodsFor: 'accessing' stamp: 'lr 8/8/2010 10:07'!
label
	^ 'Save...'! !

ORCmdEnvironment subclass: #ORCmdSelectMethodsEnvironment
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Alt-Browser-Refactory-Commands'!

!ORCmdSelectMethodsEnvironment methodsFor: 'accessing' stamp: 'lr 12/4/2009 08:06'!
environment
	| condition |
	condition := self 
		prompt: 'Select methods:' 
		initialAnswer: '[ :each | false ]'.
	^ (super environment selectMethods: (self class evaluatorClass evaluate: condition))
		label: 'Methods matching ' , condition.! !

!ORCmdSelectMethodsEnvironment methodsFor: 'accessing' stamp: 'lr 8/8/2010 10:07'!
label
	^ 'Select methods...'! !

ORCmdEnvironment subclass: #ORCmdSelectionEnvironment
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Alt-Browser-Refactory-Commands'!

!ORCmdSelectionEnvironment methodsFor: 'accessing' stamp: 'lr 11/11/2008 12:29'!
environment
	^ target browserEnvironment! !

!ORCmdSelectionEnvironment methodsFor: 'accessing' stamp: 'lr 4/21/2010 15:01'!
group
	^ #abstract! !

!ORCmdSelectionEnvironment methodsFor: 'accessing' stamp: 'lr 8/8/2010 10:07'!
label
	^ 'Selection'! !

ORCmdEnvironment subclass: #ORCmdSelfSendEnvironment
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Alt-Browser-Refactory-Commands'!

!ORCmdSelfSendEnvironment methodsFor: 'accessing' stamp: 'lr 9/8/2011 20:15'!
environment
	| parent environment matcher |
	parent := super environment.
	environment := RBParseTreeEnvironment onEnvironment: parent.
	environment label: 'Self-Sends'; matcher: (matcher := RBParseTreeSearcher new).
	matcher matches: 'self `@message: ``@args' do: [ :node :answer | node ].
	parent classesAndSelectorsDo: [ :class :selector |
		(matcher executeTree: (class compiledMethodAt: selector) parseTree initialAnswer: nil) notNil
			ifTrue: [ environment addClass: class selector: selector ] ].
	^ environment! !

!ORCmdSelfSendEnvironment methodsFor: 'accessing' stamp: 'lr 8/8/2010 10:07'!
label
	^ 'Self-sends'! !

ORCmdEnvironment subclass: #ORCmdSenderEnvironment
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Alt-Browser-Refactory-Commands'!

!ORCmdSenderEnvironment methodsFor: 'accessing' stamp: 'lr 9/1/2011 21:47'!
environment
	| selectors selector |
	selectors := target hasSelector
		ifTrue: [ target selectorAndMessages collect: [ :each | each name ] ]
		ifFalse: [ target theClass selectors ].
	selectors isEmpty
		ifFalse: [ selector := selectors first ].
	selector := OBCmdBrowseList
		selectSymbol: 'Choose Sender'
		default: selector proposed: selectors.
	selector isNil
		ifTrue: [ ^ self uiCancellationError ].
	^ (super environment referencesTo: selector)
		label: 'Senders of ' , selector printString;
		yourself! !

!ORCmdSenderEnvironment methodsFor: 'testing' stamp: 'ThierryGoubier 7/16/2012 16:21'!
isActive
	^ super isActive and: [ target isKindOf: ABClassNode ]! !

!ORCmdSenderEnvironment methodsFor: 'accessing' stamp: 'lr 9/1/2011 21:47'!
label
	^ 'Senders...'! !

ORCmdEnvironment subclass: #ORCmdSubclassesHierarchyEnvironment
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Alt-Browser-Refactory-Commands'!

!ORCmdSubclassesHierarchyEnvironment methodsFor: 'accessing' stamp: 'lr 11/11/2008 14:07'!
environment
	^ (super environment forClasses: target theNonMetaClass allSubclasses)
		label: 'Subclasses of ' , target theNonMetaClassName;
		yourself! !

!ORCmdSubclassesHierarchyEnvironment methodsFor: 'testing' stamp: 'ThierryGoubier 7/16/2012 16:22'!
isActive
	^ super isActive and: [ target isKindOf: ABClassNode ]! !

!ORCmdSubclassesHierarchyEnvironment methodsFor: 'accessing' stamp: 'lr 8/8/2010 10:07'!
label
	^ 'Subclasses'! !

ORCmdEnvironment subclass: #ORCmdSubclassesWithHierarchyEnvironment
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Alt-Browser-Refactory-Commands'!

!ORCmdSubclassesWithHierarchyEnvironment methodsFor: 'accessing' stamp: 'lr 11/11/2008 14:07'!
environment
	^ (super environment forClasses: target theNonMetaClass withAllSubclasses)
		label: 'Subclasses with ' , target theNonMetaClassName;
		yourself! !

!ORCmdSubclassesWithHierarchyEnvironment methodsFor: 'testing' stamp: 'ThierryGoubier 7/16/2012 16:22'!
isActive
	^ super isActive and: [ target isKindOf: ABClassNode ]! !

!ORCmdSubclassesWithHierarchyEnvironment methodsFor: 'accessing' stamp: 'lr 8/8/2010 10:07'!
label
	^ 'Subclasses with'! !

ORCmdEnvironment subclass: #ORCmdSuperSendEnvironment
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Alt-Browser-Refactory-Commands'!

!ORCmdSuperSendEnvironment methodsFor: 'accessing' stamp: 'lr 9/8/2011 20:15'!
environment
	| parent environment matcher |
	parent := super environment.
	environment := RBParseTreeEnvironment onEnvironment: parent.
	environment label: 'Super-Sends'; matcher: (matcher := RBParseTreeSearcher new).
	matcher matches: 'super `@message: ``@args' do: [ :node :answer | node ].
	parent classesAndSelectorsDo: [ :class :selector |
		(matcher executeTree: (class compiledMethodAt: selector) parseTree initialAnswer: nil) notNil
			ifTrue: [ environment addClass: class selector: selector ] ].
	^ environment! !

!ORCmdSuperSendEnvironment methodsFor: 'accessing' stamp: 'lr 8/8/2010 10:07'!
label
	^ 'Super-sends'! !

ORCmdEnvironment subclass: #ORCmdSuperclassesHierarchyEnvironment
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Alt-Browser-Refactory-Commands'!

!ORCmdSuperclassesHierarchyEnvironment methodsFor: 'accessing' stamp: 'lr 11/11/2008 14:07'!
environment
	^ (super environment forClasses: target theNonMetaClass allSuperclasses)
		label: 'Superclasses of ' , target theNonMetaClassName;
		yourself! !

!ORCmdSuperclassesHierarchyEnvironment methodsFor: 'testing' stamp: 'ThierryGoubier 7/16/2012 16:22'!
isActive
	^ super isActive and: [ target isKindOf: ABClassNode ]! !

!ORCmdSuperclassesHierarchyEnvironment methodsFor: 'accessing' stamp: 'lr 8/8/2010 10:07'!
label
	^ 'Superclasses'! !

ORCmdEnvironment subclass: #ORCmdSuperclassesWithHierarchyEnvironment
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Alt-Browser-Refactory-Commands'!

!ORCmdSuperclassesWithHierarchyEnvironment methodsFor: 'accessing' stamp: 'lr 11/11/2008 14:07'!
environment
	^ (super environment forClasses: target theNonMetaClass withAllSuperclasses)
		label: 'Superclasses with ' , target theNonMetaClassName;
		yourself! !

!ORCmdSuperclassesWithHierarchyEnvironment methodsFor: 'testing' stamp: 'ThierryGoubier 7/16/2012 16:22'!
isActive
	^ super isActive and: [ target isKindOf: ABClassNode ]! !

!ORCmdSuperclassesWithHierarchyEnvironment methodsFor: 'accessing' stamp: 'lr 8/8/2010 10:07'!
label
	^ 'Superclasses with'! !

ORCmdEnvironment subclass: #ORCmdUnionEnvironment
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Alt-Browser-Refactory-Commands'!

!ORCmdUnionEnvironment methodsFor: 'accessing' stamp: 'lr 4/21/2010 15:39'!
environment
	^ super environment | (self selectEnvironment: 'Select scope to build the union with:')! !

!ORCmdUnionEnvironment methodsFor: 'accessing' stamp: 'lr 4/21/2010 14:58'!
group
	^ #logical! !

!ORCmdUnionEnvironment methodsFor: 'testing' stamp: 'lr 4/21/2010 15:34'!
isEnabled
	^ super isEnabled and: [ super environment isSystem not and: [ SavedEnvironments notEmpty ] ]! !

!ORCmdUnionEnvironment methodsFor: 'accessing' stamp: 'lr 8/8/2010 10:07'!
label
	^ 'Union...'! !

ORCommand subclass: #ORCmdFormat
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Alt-Browser-Refactory-Commands'!

!ORCmdFormat class methodsFor: 'testing' stamp: 'lr 6/14/2007 19:49'!
takesText
	^ true! !

!ORCmdFormat methodsFor: 'execution' stamp: 'lr 6/4/2010 13:36'!
execute
	"Now this is utterly ugly, but unfortunately I see no better way doing this. This is not going to work in any view other than morphic and will silently fail."

	| panel class morph source tree formatted |
	panel := requestor browser definitionPanel.
	class := Smalltalk classNamed: #OBPluggableTextMorph.
	class isNil
		ifTrue: [ ^ self ].
	morph := class allSubInstances
		detect: [ :each | each model == panel ]
		ifNone: [ ^ self ].
	source := morph text asString.
	tree := RBParser 
		parseMethod: source
		onError: [ :msg :pos | ^ self ].
	formatted := tree formattedCode.
	formatted = source
		ifTrue: [ ^ self ].
	morph editString: formatted; hasUnacceptedEdits: true! !

!ORCmdFormat methodsFor: 'accessing' stamp: 'lr 10/3/2007 20:11'!
group
	^ #general! !

!ORCmdFormat methodsFor: 'testing' stamp: 'ThierryGoubier 7/16/2012 16:40'!
isActive
	^" (target isKindOf: OBTextSelection) or: [ "(target isKindOf: ABMethodNode) "and: [ (target isKindOf: OBMethodVersionNode) not" and: [ requestor isSelected: target ] "] ] "! !

!ORCmdFormat methodsFor: 'accessing' stamp: 'lr 1/28/2010 15:15'!
keystroke
	^ $r! !

!ORCmdFormat methodsFor: 'accessing' stamp: 'lr 8/8/2010 10:07'!
label
	^ 'Format'! !

ORCommand subclass: #ORCmdOpen
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Alt-Browser-Refactory-Commands'!

!ORCmdOpen methodsFor: 'accessing' stamp: 'lr 8/8/2010 10:09'!
cluster
	^ #Refactor! !

!ORCmdOpen methodsFor: 'private' stamp: 'lr 5/30/2008 10:15'!
definition: aDefinition
	requestor announce: (OBDefinitionChanged definition: aDefinition)! !

!ORCmdOpen methodsFor: 'accessing' stamp: 'lr 2/26/2009 17:03'!
group
	^ #open! !

ORCmdOpen subclass: #ORCmdOpenLint
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Alt-Browser-Refactory-Commands'!

!ORCmdOpenLint methodsFor: 'execution' stamp: 'ThierryGoubier 7/16/2012 16:52'!
execute
	self halt"ORCriticsBrowser 
		openRule: RBCompositeLintRule allRules
		environment: self environment"! !

!ORCmdOpenLint methodsFor: 'accessing' stamp: 'lr 8/8/2010 10:07'!
label
	^ 'Code critics'! !

ORCmdOpen subclass: #ORCmdOpenRewriter
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Alt-Browser-Refactory-Commands'!

!ORCmdOpenRewriter methodsFor: 'execution' stamp: 'ThierryGoubier 7/16/2012 16:53'!
execute
	self halt"self definition: (ORRewriterDefinition on: self environment)"! !

!ORCmdOpenRewriter methodsFor: 'accessing' stamp: 'lr 9/2/2011 19:20'!
label
	^ 'Rewrite code...'! !

ORCmdOpen subclass: #ORCmdOpenSearcher
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Alt-Browser-Refactory-Commands'!

!ORCmdOpenSearcher methodsFor: 'execution' stamp: 'ThierryGoubier 7/16/2012 16:53'!
execute
	"self definition: (ORSearcherDefinition on: self environment)"self halt! !

!ORCmdOpenSearcher methodsFor: 'accessing' stamp: 'lr 9/2/2011 19:19'!
label
	^ 'Search code...'! !

ORCmdOpen subclass: #ORCmdOpenTypeClass
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Alt-Browser-Refactory-Commands'!

!ORCmdOpenTypeClass methodsFor: 'execution' stamp: 'ThierryGoubier 7/16/2012 16:49'!
execute
	| typer |
	typer := RBRefactoryTyper new.
	typer runOn: target theClass.
"	self definition: (OBTextDefinition text: typer printString)"! !

!ORCmdOpenTypeClass methodsFor: 'testing' stamp: 'ThierryGoubier 7/16/2012 16:22'!
isActive
	^ super isActive and: [ target isKindOf: ABClassNode ]! !

!ORCmdOpenTypeClass methodsFor: 'accessing' stamp: 'lr 8/8/2010 10:07'!
label
	^ 'Type class'! !

ORCmdOpen subclass: #ORCmdOpenTypeMethod
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Alt-Browser-Refactory-Commands'!

!ORCmdOpenTypeMethod methodsFor: 'execution' stamp: 'ThierryGoubier 7/16/2012 16:49'!
execute
	| typer tree messages stream types |
	typer := RBRefactoryTyper new.
	tree := RBParser parseMethod: target source.
	messages := tree allChildren
		inject: OrderedCollection new
		into: [ :result :node |
			(node isMessage and: [ node receiver isVariable ])
				ifTrue: [ result addLast: node ].
			result ].
	stream := String new writeStream.
	tree allDefinedVariables do: [ :name |
		types := typer findTypeFor: ((messages 
			select: [ :each | each receiver name = name ])
			collect: [ :each | each selector ]).
		stream nextPutAll: name; nextPutAll: ': <'.
		types
			do: [ :type | stream nextPutAll: type name ]
			separatedBy: [ stream nextPutAll: ' | ' ].
		stream nextPut: $>; cr ].
"	self definition: (OBTextDefinition text: stream contents)"! !

!ORCmdOpenTypeMethod methodsFor: 'testing' stamp: 'lr 8/10/2009 17:32'!
isActive
	^ super isActive and: [ target hasSelector ]! !

!ORCmdOpenTypeMethod methodsFor: 'accessing' stamp: 'lr 8/8/2010 10:07'!
label
	^ 'Type method'! !

ORCommand subclass: #ORCmdRecompile
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Alt-Browser-Refactory-Commands'!

!ORCmdRecompile methodsFor: 'accessing' stamp: 'lr 8/8/2010 10:09'!
cluster
	^ #Refactor! !

!ORCmdRecompile methodsFor: 'execution' stamp: 'lr 2/26/2009 20:50'!
execute
	OBWaitRequest block: [
		self environment classesAndSelectorsDo: [ :class :selector |
			class recompile: selector from: class ] ]! !

!ORCmdRecompile methodsFor: 'accessing' stamp: 'lr 2/26/2009 17:03'!
group
	^ #tools! !

!ORCmdRecompile methodsFor: 'testing' stamp: 'lr 12/30/2009 22:39'!
isActive
	^ super isActive and: [ self environment isSystem not ]! !

!ORCmdRecompile methodsFor: 'accessing' stamp: 'lr 8/8/2010 10:07'!
label
	^ 'Recompile'! !

ORCommand subclass: #ORCmdReformat
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Alt-Browser-Refactory-Commands'!

!ORCmdReformat methodsFor: 'accessing' stamp: 'lr 8/8/2010 10:09'!
cluster
	^ #Refactor! !

!ORCmdReformat methodsFor: 'accessing' stamp: 'lr 2/26/2009 20:47'!
group
	^ #tools! !

!ORCmdReformat methodsFor: 'testing' stamp: 'lr 12/30/2009 22:42'!
isActive
	^ super isActive and: [ self environment isSystem not ]! !

!ORCmdReformat methodsFor: 'accessing' stamp: 'lr 8/8/2010 10:07'!
label
	^ 'Reformat'! !

!ORCmdReformat methodsFor: 'accessing' stamp: 'ThierryGoubier 7/16/2012 16:52'!
refactoring
	"^ ORPrettyPrintCodeRefactoring new"! !

ORCommand subclass: #ORCmdSelectCode
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Alt-Browser-Refactory-Commands'!

!ORCmdSelectCode class methodsFor: 'testing' stamp: 'lr 12/11/2009 08:48'!
takesNodes
	^ false! !

!ORCmdSelectCode class methodsFor: 'testing' stamp: 'lr 12/11/2009 08:48'!
takesText
	^ true! !

!ORCmdSelectCode methodsFor: 'execution' stamp: 'lr 4/25/2011 11:36'!
execute
	| tree node |
	tree := self currentNode hasSelector
		ifTrue: [ RBParser parseMethod: target fullText onError: [ :err :pos | ^ self ] ]
		ifFalse: [ RBParser parseExpression: target fullText onError: [ :err :pos | ^ self ] ].
	node := self 
		selectionFor: ((tree bestNodeFor: target selection)
			ifNil: [ ^ self ])
		interval: target selection.
	node isNil
		ifFalse: [ requestor selection: node sourceInterval ]! !

!ORCmdSelectCode methodsFor: 'accessing' stamp: 'lr 12/11/2009 14:21'!
selectionFor: aNode interval: anInterval
	"Answer a new node a given aNode in the current selection anInterval."

	^ aNode! !

!ORCmdSelectCode methodsFor: 'testing' stamp: 'lr 4/25/2011 11:41'!
wantsMenu
	^ false! !

ORCmdSelectCode subclass: #ORCmdSelectNext
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Alt-Browser-Refactory-Commands'!

!ORCmdSelectNext methodsFor: 'accessing' stamp: 'ThierryGoubier 7/16/2012 16:33'!
keystroke
	"^ OBKeystroke key: Character arrowRight shift: false control: false option: true command: false"! !

!ORCmdSelectNext methodsFor: 'accessing' stamp: 'lr 8/8/2010 10:07'!
label
	^ 'Next'! !

!ORCmdSelectNext methodsFor: 'accessing' stamp: 'lr 4/25/2011 11:43'!
selectionFor: aNode interval: anInterval
	| nodes index |
	nodes := aNode methodNode allChildren.
	index := nodes identityIndexOf: aNode ifAbsent: [ ^ aNode ].
	[ index < nodes size and: [ (nodes at: index) sourceInterval = anInterval ] ]
		whileTrue: [ index := index + 1 ].
	^ nodes at: index! !

ORCmdSelectCode subclass: #ORCmdSelectNextStatement
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Alt-Browser-Refactory-Commands'!

!ORCmdSelectNextStatement methodsFor: 'accessing' stamp: 'ThierryGoubier 7/16/2012 16:33'!
keystroke
	"^ OBKeystroke key: Character arrowRight shift: true control: false option: true command: false"! !

!ORCmdSelectNextStatement methodsFor: 'accessing' stamp: 'lr 4/25/2011 11:44'!
label
	^ 'Next'! !

!ORCmdSelectNextStatement methodsFor: 'accessing' stamp: 'lr 4/25/2011 12:03'!
selectionFor: aNode interval: anInterval
	| nodes index |
	nodes := aNode methodNode allChildren
		select: [ :each | each parent isNil or: [ each parent isSequence ] ].
	index := nodes identityIndexOf: aNode statementNode ifAbsent: [ ^ aNode ].
	[ index < nodes size and: [ (nodes at: index) sourceInterval = anInterval ] ]
		whileTrue: [ index := index + 1 ].
	^ nodes at: index! !

ORCmdSelectCode subclass: #ORCmdSelectPrevious
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Alt-Browser-Refactory-Commands'!

!ORCmdSelectPrevious methodsFor: 'accessing' stamp: 'ThierryGoubier 7/16/2012 16:33'!
keystroke
	"^ OBKeystroke key: Character arrowLeft shift: false control: false option: true command: false"! !

!ORCmdSelectPrevious methodsFor: 'accessing' stamp: 'lr 8/8/2010 10:07'!
label
	^ 'Previous'! !

!ORCmdSelectPrevious methodsFor: 'accessing' stamp: 'lr 4/25/2011 11:43'!
selectionFor: aNode interval: anInterval
	| nodes index |
	nodes := aNode methodNode allChildren.
	index := nodes identityIndexOf: aNode ifAbsent: [ ^ aNode ].
	[ 1 < index and: [ (nodes at: index) sourceInterval = anInterval ] ]
		whileTrue: [ index := index - 1 ].
	^ nodes at: index! !

ORCmdSelectCode subclass: #ORCmdSelectPreviousStatement
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Alt-Browser-Refactory-Commands'!

!ORCmdSelectPreviousStatement methodsFor: 'accessing' stamp: 'ThierryGoubier 7/16/2012 16:33'!
keystroke
	"^ OBKeystroke key: Character arrowLeft shift: true control: false option: true command: false"! !

!ORCmdSelectPreviousStatement methodsFor: 'accessing' stamp: 'lr 4/25/2011 12:01'!
label
	^ 'Previous'! !

!ORCmdSelectPreviousStatement methodsFor: 'accessing' stamp: 'lr 4/25/2011 12:03'!
selectionFor: aNode interval: anInterval
	| nodes index |
	nodes := aNode methodNode allChildren
		select: [ :each | each parent isNil or: [ each parent isSequence ] ].
	index := nodes identityIndexOf: aNode statementNode ifAbsent: [ ^ aNode ].
	[ 1 < index and: [ (nodes at: index) sourceInterval = anInterval ] ]
		whileTrue: [ index := index - 1 ].
	^ nodes at: index! !

ORCommand subclass: #ORCmdToggleContainment
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Alt-Browser-Refactory-Commands'!

!ORCmdToggleContainment methodsFor: 'execution' stamp: 'lr 11/25/2009 10:40'!
execute
	| current selected |
	current := self environment.
	selected := target browserEnvironment.
	(target definedWithinBrowserEnvironment: self environment)
		ifTrue: [ 
			selected classesAndSelectorsDo: [ :class :selector |
				current removeClass: class selector: selector ] ]
		ifFalse: [
			selected classesAndSelectorsDo: [ :class :selector |
				current addClass: class selector: selector ] ].
	requestor browser signalRefresh! !

!ORCmdToggleContainment methodsFor: 'testing' stamp: 'lr 8/7/2009 12:58'!
isActive
	^ super isActive and: [ self environment isSelectorEnvironment ]! !

!ORCmdToggleContainment methodsFor: 'accessing' stamp: 'lr 5/21/2007 21:27'!
keystroke
	^ $/! !

!ORCmdToggleContainment methodsFor: 'accessing' stamp: 'lr 8/8/2010 10:07'!
label
	^ 'Toggle'! !

!ORCmdToggleContainment methodsFor: 'accessing' stamp: 'lr 2/9/2008 12:49'!
order
	^ '0'! !

!ORCommand class methodsFor: 'accessing' stamp: 'lr 12/18/2009 20:31'!
promptOnRefactoring
	^ PromptOnRefactoring ifNil: [ PromptOnRefactoring := true ]! !

!ORCommand class methodsFor: 'accessing' stamp: 'lr 12/18/2009 20:31'!
promptOnRefactoring: aBoolean
	PromptOnRefactoring := aBoolean! !

!ORCommand class methodsFor: 'settings' stamp: 'lr 12/18/2009 21:19'!
settingsOn: aBuilder
	<systemsettings>
	
	(aBuilder setting: #promptOnRefactoring)
		target: self;
		parentName: #refactoring;
		label: 'Prompt on refactoring';
		description: 'Show the changes before applying a refactoring'! !

!ORCommand methodsFor: 'accessing' stamp: 'lr 2/7/2008 19:17'!
browser
	^ requestor browser! !

!ORCommand methodsFor: 'accessing-conveniance' stamp: 'lr 10/15/2007 09:20'!
chooseFrom: anArray
	^ self chooseFrom: anArray title: nil! !

!ORCommand methodsFor: 'accessing-conveniance' stamp: 'lr 3/1/2008 21:58'!
chooseFrom: anArray title: aString
	^ self chooseFrom: anArray title: aString lines: #()! !

!ORCommand methodsFor: 'accessing-conveniance' stamp: 'lr 3/1/2008 21:58'!
chooseFrom: anArray title: aString lines: aCollection 
	anArray isEmpty
		ifTrue: [ self uiCancellationError ].
	anArray size = 1
		ifTrue: [ ^ anArray first ].
	^ (OBChoiceRequest prompt: aString labels: anArray values: anArray lines: aCollection)
		ifNil: [ self uiCancellationError ]! !

!ORCommand methodsFor: 'accessing-conveniance' stamp: 'lr 1/17/2010 11:30'!
chooseMultipleFrom: anArray
	^ self chooseMultipleFrom: anArray title: nil! !

!ORCommand methodsFor: 'accessing-conveniance' stamp: 'lr 1/17/2010 11:30'!
chooseMultipleFrom: anArray title: aString
	^ self chooseMultipleFrom: anArray title: aString lines: #()! !

!ORCommand methodsFor: 'accessing-conveniance' stamp: 'lr 1/17/2010 11:30'!
chooseMultipleFrom: anArray title: aString lines: aCollection 
	^ anArray isEmpty
		ifTrue: [ anArray copyEmpty ]
		ifFalse: [
			(OBMultipleChoiceRequest prompt: aString labels: anArray values: anArray lines: aCollection)
				ifNil: [ self uiCancellationError ] ]! !

!ORCommand methodsFor: 'accessing-variables' stamp: 'ThierryGoubier 7/16/2012 16:29'!
classVariables
	| variables |
	variables := self currentNode theNonMetaClass allClassVarNames
		asArray sort.
	^ (variables includes: self selection)
		ifTrue: [ Array with: self selection ]
		ifFalse: [ 
			"(target isKindOf: OBClassVariableNode)
				ifTrue: [ Array with: target name ]
				ifFalse: [" variables "]" ]! !

!ORCommand methodsFor: 'accessing-conveniance' stamp: 'lr 10/15/2007 09:21'!
confirm: aString
	^ (OBConfirmationRequest prompt: aString confirm: 'Yes' cancel: 'No')
		ifNil: [ self uiCancellationError ]! !

!ORCommand methodsFor: 'accessing' stamp: 'lr 3/15/2008 09:08'!
currentNode
	^ self browser currentOrRootNode! !

!ORCommand methodsFor: 'accessing' stamp: 'lr 1/20/2010 18:10'!
description
	^ String streamContents: [ :stream |
		self cluster isNil
			ifFalse: [ stream nextPutAll: self cluster; nextPutAll: ', ' ].
		stream nextPutAll: self label ]! !

!ORCommand methodsFor: 'accessing' stamp: 'lr 2/7/2008 19:20'!
environment
	^ self browser environment! !

!ORCommand methodsFor: 'accessing' stamp: 'cwp 9/30/2007 22:03'!
group
	^ #refactory! !

!ORCommand methodsFor: 'private' stamp: 'lr 10/5/2010 16:09'!
handleError: anException
	anException actionBlock isNil
		ifTrue: [ self inform: anException messageText ]
		ifFalse: [ 
			(self confirm: anException messageText) 
				ifTrue: [ anException actionBlock value ] ].
	anException return! !

!ORCommand methodsFor: 'private' stamp: 'lr 10/5/2010 16:05'!
handleWarning: anException 
	| message |
	message := (anException messageText endsWith: '?')
		ifTrue: [ anException messageText ]
		ifFalse: [ anException messageText , String cr , 'Do you want to proceed?' ].
	(self confirm: message)
		ifTrue: [ anException resume ]
		ifFalse: [ anException return ]! !

!ORCommand methodsFor: 'accessing-conveniance' stamp: 'lr 2/9/2008 16:13'!
inform: aString
	^ OBInformRequest message: aString! !

!ORCommand methodsFor: 'accessing-variables' stamp: 'ThierryGoubier 7/16/2012 16:32'!
instanceVariables
	| variables |
	variables := self currentNode theClass allInstVarNames
		asArray sort.
	^ (variables includes: self selection)
		ifTrue: [ Array with: self selection ]
		ifFalse: [
			"(target isKindOf: OBInstanceVariableNode)
				ifTrue: [ Array with: target name ]
				ifFalse: [" variables" ]" ]! !

!ORCommand methodsFor: 'testing' stamp: 'ThierryGoubier 7/16/2012 16:50'!
isActive
"	(self class takesText and: [ target isKindOf: OBTextSelection ])
		ifTrue: [ ^ true ].
"	(self class takesNodes and: [ requestor isSelected: target ])
		ifTrue: [ ^ true ].
	^ false! !

!ORCommand methodsFor: 'actions' stamp: 'lr 4/21/2010 15:39'!
openEnvironment: anEnvironment
	anEnvironment isSystem
		ifTrue: [ ^ target browse ].
	anEnvironment isEmpty
		ifTrue: [ ^ self inform: 'Empty scope' ].
	self waitWhile: [
		| instance |
		instance := anEnvironment browserInstance.
		[ instance jumpTo: target ] 
			ifError: [ instance jumpToRoot ].
		instance open ]! !

!ORCommand methodsFor: 'private' stamp: 'lr 9/8/2011 20:10'!
performChange: aChange
	self waitWhile: [
		RBRefactoryChangeManager instance
			performChange: aChange.
		self refreshChange: aChange ]! !

!ORCommand methodsFor: 'private' stamp: 'ThierryGoubier 7/16/2012 16:51'!
performRefactoring: aRefactoring
	"Try to properly label aRefactoring and perform it or open the changes browser, depending on the preferences of the user."

	self refactoringOptions: aRefactoring.
	self label isNil ifFalse: [
		aRefactoring model name: (String streamContents: [ :stream |
			self cluster isNil
				ifFalse: [ stream nextPutAll: self cluster; nextPutAll: ', ' ].
			stream nextPutAll: self label ]) ].
	self waitWhile: [
		self class promptOnRefactoring
			ifFalse: [ aRefactoring execute ]
			ifTrue: [
				| browser |
				aRefactoring primitiveExecute.
"				browser := ORChangesBrowser 
					change: aRefactoring changes.
				browser closeBlock: [ self refreshRefactoring: aRefactoring ].
				browser open" ].
		self refreshRefactoring: aRefactoring ]! !

!ORCommand methodsFor: 'accessing-conveniance' stamp: 'lr 12/4/2009 08:04'!
prompt: aString
	^ self prompt: aString initialAnswer: String new! !

!ORCommand methodsFor: 'accessing-conveniance' stamp: 'lr 12/4/2009 08:04'!
prompt: aString initialAnswer: aTemplateString
	^ (OBMultiLineTextRequest prompt: aString template: aTemplateString)
		ifNil: [ self uiCancellationError ]! !

!ORCommand methodsFor: 'private' stamp: 'lr 6/15/2010 13:13'!
refactoringOptions: aRefactoring
	aRefactoring
		setOption: #implementorToInline
		toUse: [ :ref :imps | self requestImplementorToInline: imps ];
		setOption: #methodName
		toUse: [ :ref :name | self requestMethodNameFor: name ];
		setOption: #selfArgumentName
		toUse: [ :ref | self requestSelfArgumentName ];
		setOption: #selectVariableToMoveTo
		toUse: [ :ref :class :selector | self selectVariableToMoveMethodTo: selector class: class ];
		setOption: #variableTypes
		toUse: [ :ref :types :selected | self selectVariableTypesFrom: types selected: selected for: ref ];
		setOption: #extractAssignment
		toUse: [ :ref :string | self shouldExtractAssignmentTo: string ];
		setOption: #inlineExpression
		toUse: [ :ref :string | self shouldInlineExpression: string ];
		setOption: #alreadyDefined
		toUse: [ :ref :class :selector | self shouldOverride: selector in: class ];
		setOption: #useExistingMethod
		toUse: [ :ref :selector | self shouldUseExistingMethod: selector ];
		setOption: #openBrowser
		toUse: [ :ref :env | self openEnvironment: env ]! !

!ORCommand methodsFor: 'actions' stamp: 'lr 12/13/2010 08:24'!
refresh
	"Refresh the browser."
	
	self browser signalRefresh! !

!ORCommand methodsFor: 'actions' stamp: 'lr 12/13/2010 08:23'!
refreshChange: aChange
	"Called after a successful change application to refresh the views."
	
	self refresh! !

!ORCommand methodsFor: 'actions' stamp: 'lr 12/13/2010 08:23'!
refreshRefactoring: aRefactoring
	"Called after a successful refactoring to refresh the browser."
	
	self refresh! !

!ORCommand methodsFor: 'accessing-conveniance' stamp: 'lr 10/15/2007 09:20'!
request: aString
	^ self request: aString initialAnswer: String new! !

!ORCommand methodsFor: 'accessing-conveniance' stamp: 'lr 10/15/2007 09:21'!
request: aString initialAnswer: aTemplateString
	^ (OBTextRequest prompt: aString template: aTemplateString)
		ifNil: [ self uiCancellationError ]! !

!ORCommand methodsFor: 'actions' stamp: 'lr 8/8/2010 15:04'!
requestImplementorToInline: aCollection
	^ self
		chooseFrom: aCollection
		title: 'Which implementation should be inlined?'! !

!ORCommand methodsFor: 'actions' stamp: 'ThierryGoubier 7/16/2012 16:52'!
requestMethodNameFor: aMethodName
	self halt"^ ORMethodNameRequest methodName: aMethodName"! !

!ORCommand methodsFor: 'actions' stamp: 'lr 3/1/2008 22:55'!
requestSelfArgumentName
	^ self request: 'Enter name for argument to refer to "self" in extracted method'! !

!ORCommand methodsFor: 'actions' stamp: 'lr 3/1/2008 21:59'!
selectVariableToMoveMethodTo: aSelector class: aClass
	| parseTree nameList | 
	parseTree := aClass parseTreeFor: aSelector.
	parseTree isNil ifTrue: [ 
		parseTree := RBMethodNode 
			selector: #value
			body: (RBSequenceNode statements: #()) ].
	nameList := OrderedCollection new.
	nameList
		addAll: parseTree argumentNames asSortedCollection;
		addAll: aClass allInstanceVariableNames asSortedCollection.
	^ self 
		chooseFrom: nameList 
		title: 'Select variable to move method into:'
		lines: (Array with: parseTree argumentNames size)! !

!ORCommand methodsFor: 'actions' stamp: 'GuillermoPolito 1/21/2012 22:55'!
selectVariableTypesFrom: aCollectionOfTypes selected: aSelectedCollection for: aRefactoring
	| stream result |
	stream := WriteStream on: String new.
	aCollectionOfTypes
		do: [ :each | stream nextPutAll: each name ]
		separatedBy: [ stream cr ].
	result := OBMultiLineTextRequest
		prompt: 'Select classes to move to:'
		template: stream contents.
	result isNil
		ifTrue: [ ^ self uiCancellationError ].
	^ (result findTokens: String crlf)
		collect: [ :each | aRefactoring model classFor: (Smalltalk classNamed: each trimBoth) ]
		! !

!ORCommand methodsFor: 'accessing' stamp: 'ThierryGoubier 7/16/2012 16:50'!
selection
"	^ (target isKindOf: OBTextSelection)
		ifTrue: [ target text asString ]"! !

!ORCommand methodsFor: 'actions' stamp: 'lr 3/1/2008 21:42'!
shouldExtractAssignmentTo: aString
	^ self confirm: ('Do you want to extract the assignment of <1s> at the end of selection?' expandMacrosWith: aString)! !

!ORCommand methodsFor: 'actions' stamp: 'lr 3/1/2008 21:42'!
shouldInlineExpression: aString
	^ self confirm: ('Do you want to inline <1s>? If not, it will be assigned as a temporary.' expandMacrosWith: aString)! !

!ORCommand methodsFor: 'actions' stamp: 'lr 3/1/2008 21:54'!
shouldOverride: aSelector in: aClass 
	^ self confirm: ('<1s> is already defined in the <2p> hierarchy. Extracting it to an existing selector may change behavior. Do you wish to use <1s> anyway?' expandMacrosWith: aSelector with: aClass)! !

!ORCommand methodsFor: 'actions' stamp: 'lr 3/1/2008 21:41'!
shouldUseExistingMethod: aSelector
	^ self confirm: ('Use existing method <1s> instead of creating new method?' expandMacrosWith: aSelector)! !

!ORCommand methodsFor: 'private' stamp: 'ThierryGoubier 7/16/2012 16:53'!
uiCancellationError
	"The user pressed Cancel or there were nothing to ask for. The error must be catched by #execute in order to cancel the action."

	"^ ORUICancellationError signal"self halt! !

!ORCommand methodsFor: 'private' stamp: 'lr 5/14/2008 15:47'!
waitWhile: aBlock
	^ OBWaitRequest block: aBlock! !

Object subclass: #OBCommandCluster
	instanceVariableNames: 'commands label'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Alt-Browser-Commands'!

!OBCommandCluster classSide methodsFor: 'instance creation' stamp: 'cwp 9/30/2007 20:24'!
label: aString
	^ self new setLabel: aString! !

!OBCommandCluster methodsFor: 'accessing' stamp: 'cwp 9/30/2007 20:19'!
addCommand: aCommand
	commands add: aCommand! !

!OBCommandCluster methodsFor: 'accessing' stamp: 'lr 7/3/2009 22:27'!
addItemToMenu: aMenu 
	| submenu |
	submenu := aMenu 
		addSubmenu: label
		enabled: self isEnabled.
	self populateMenu: submenu! !

!OBCommandCluster methodsFor: 'accessing' stamp: 'cwp 9/30/2007 20:40'!
group
	^ #zclusters! !

!OBCommandCluster methodsFor: 'accessing' stamp: 'lr 4/8/2010 11:07'!
groupedCommands
	| groups |
	groups := commands 
				groupBy: [:svc | svc group]
				having: [:group | group isEmpty not].
	groups := groups collect: [:ea | ea asArray sort: [:a :b | a order <= b order]].
	^ groups asArray sort: [:a :b | a anyOne group <= b anyOne group]! !

!OBCommandCluster methodsFor: 'accessing' stamp: 'lr 7/3/2009 22:27'!
initialize
	commands := IdentitySet new! !

!OBCommandCluster methodsFor: 'accessing' stamp: 'cwp 9/30/2007 21:54'!
isEnabled
	^ commands anySatisfy: [:ea | ea isEnabled]! !

!OBCommandCluster methodsFor: 'accessing' stamp: 'cwp 9/30/2007 20:16'!
label
	^ label! !

!OBCommandCluster methodsFor: 'accessing' stamp: 'lr 4/8/2010 11:07'!
order
	^ self label! !

!OBCommandCluster methodsFor: 'accessing' stamp: 'cwp 9/30/2007 21:01'!
populateMenu: aMenu 
	self groupedCommands	
		do: [:group | group do: [:cmd | cmd addItemToMenu: aMenu]]
		separatedBy: [aMenu addLine]! !

!OBCommandCluster methodsFor: 'initialize-release' stamp: 'lr 7/3/2009 22:27'!
setLabel: aSymbol 
	label := aSymbol! !

Object subclass: #OBDefinition
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Alt-Browser-Utilities'!

!OBDefinition commentStamp: 'cwp 1/7/2005 23:38' prior: 0!
The responsibility of a definition is to express a node's composition textually and respond to changes in the text by updating the node it represents. For example,a file browser might use a file definition to allow editing of a files contents.!

OBDefinition subclass: #OBClassCommentDefinition
	instanceVariableNames: 'theClass'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Alt-Browser-Standard-Definitions'!

!OBClassCommentDefinition class methodsFor: 'instance creation' stamp: 'cwp 8/7/2007 00:09'!
on: aClass
	^ self new setClass: aClass! !

!OBClassCommentDefinition methodsFor: 'accessing' stamp: 'dc 10/6/2007 15:26'!
selectedClass
	^ theClass ! !

!OBClassCommentDefinition methodsFor: 'accessing' stamp: 'lr 5/29/2010 08:51'!
setClass: aClass
	theClass := aClass theNonMetaClass! !

!OBClassCommentDefinition methodsFor: 'accessing' stamp: 'lr 5/29/2010 08:53'!
template
	^ theClass classCommentBlank! !

!OBClassCommentDefinition methodsFor: 'callbacks' stamp: 'lr 5/29/2010 08:53'!
text
	| comment |
	comment := theClass organization classComment.
	^ comment isEmpty 
		ifTrue: [ self template ] 
		ifFalse: [ comment ]! !

!OBClassCommentDefinition methodsFor: 'callbacks' stamp: 'ThierryGoubier 7/16/2012 16:38'!
text: aText
	theClass
		comment: aText asString
		stamp: RBPharoPlatform changeStamp.
	^ true! !

OBDefinition subclass: #OBClassDefinition
	instanceVariableNames: 'environment template'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Alt-Browser-Standard-Definitions'!

!OBClassDefinition commentStamp: 'cwp 1/8/2005 13:13' prior: 0!
OBClassDefinition presents a textual interface for examining, modifying and creating classes. Given a class, it knows how to display the definition expression that reflects it's current state, and knows how to create or modify a class given a definition expression.

OBClassDefinition implements a number of safety checks when defining or redefining classes, to ensure that existing classes are not accidentally overwritten.!

!OBClassDefinition class methodsFor: 'instance creation' stamp: ''!
environment: anEnvironment template: aString 
	^ self new setEnvironment: anEnvironment template: aString! !

!OBClassDefinition methodsFor: 'callbacks' stamp: ''!
accept: aText notifying: aController
	^ self defineClass: aText notifying: aController! !

!OBClassDefinition methodsFor: 'confirmation' stamp: ''!
confirmDefinition: definition
	"Check to make sure the user isn't accidentally over-writing an existing class."
	
	(((self isRedefinition: definition) not) and: [self definedClassExists: definition])
		ifTrue: [^ self confirmRedefinition: definition]
		ifFalse: [^ true]! !

!OBClassDefinition methodsFor: 'confirmation' stamp: 'lr 11/26/2010 00:01'!
confirmRedefinition: definition
	| newName answer |
	newName := self nameOfClassDefinedBy: definition.
	answer := OBConfirmationRequest
		prompt: newName , ' is an existing class in this system. Redefining it might cause serious problems. Is this really what you want to do?'
		confirm: 'Redefine'.
	^ answer ifNil: [false]! !

!OBClassDefinition methodsFor: 'class definition' stamp: ''!
defineClass: definition notifying: aController
	| evaluator newClass |
	(self confirmDefinition: definition) ifFalse: [^ false].
	evaluator := self evaluatorForDefinition: definition.
	newClass := evaluator
				evaluate: definition
				notifying: aController
				logged: true.
	newClass ifNil: [^ false].
	self signalSelectionOf: newClass.
	^ true
! !

!OBClassDefinition methodsFor: 'confirmation' stamp: ''!
definedClassExists: definition
	^ environment hasClassNamed: (self nameOfClassDefinedBy: definition)! !

!OBClassDefinition methodsFor: 'class definition' stamp: ''!
evaluatorForDefinition: definition
	| tokens |
	tokens := Scanner new scanTokens: definition.
	^ (environment at: tokens first ifAbsent: [nil]) subclassDefinerClass! !

!OBClassDefinition methodsFor: 'confirmation' stamp: ''!
isRedefinition: aDefinition
	^ (self nameOfClassDefinedBy: aDefinition) = (self nameOfClassDefinedBy: template)! !

!OBClassDefinition methodsFor: 'confirmation' stamp: ''!
nameOfClassDefinedBy: definition
	^ (Scanner new scanTokens: definition) third! !

!OBClassDefinition methodsFor: 'confirmation' stamp: 'lr 11/22/2010 22:53'!
nameOfMetaclassDefinedBy: definition
	^ (Scanner new scanTokens: definition) first! !

!OBClassDefinition methodsFor: 'confirmation' stamp: 'lr 11/22/2010 22:53'!
selectedClass
	^ environment at: (self nameOfClassDefinedBy: template) ifAbsent: [ environment at: (self nameOfMetaclassDefinedBy: template) ifAbsent: [ nil ] ]! !

!OBClassDefinition methodsFor: 'initializing' stamp: ''!
setEnvironment: anEnvironment template: aText
	environment := anEnvironment.
	template := aText.! !

!OBClassDefinition methodsFor: 'class definition' stamp: 'lr 11/25/2010 23:43'!
signalSelectionOf: aClass
	aClass asNode signalCreation! !

!OBClassDefinition methodsFor: 'callbacks' stamp: ''!
text
	^ template! !

OBClassDefinition subclass: #ORClassDefinition
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Alt-Browser-Refactory-Definitions-Replacement'!

!ORClassDefinition methodsFor: 'class definition' stamp: 'lr 9/8/2011 20:10'!
defineClass: definition notifying: aController
	| change |
	(self confirmDefinition: definition)
		ifFalse: [ ^ false ].
	change := RBRefactoryDefinitionChange
		definition: definition for: aController.
	RBRefactoryChangeManager instance
		performChange: change.
	change definedClass ifNil: [ ^ false ].
	self signalSelectionOf: change definedClass.
	^ true
! !

!OBDefinition methodsFor: 'callbacks' stamp: 'cwp 3/22/2004 20:51'!
accept: aText notifying: aController
	^ self text: aText! !

!OBDefinition methodsFor: 'updating' stamp: 'cwp 7/25/2006 18:26'!
asAnnouncement
	^ OBDefinitionChanged definition: self! !

!OBDefinition methodsFor: 'callbacks' stamp: 'cwp 3/23/2004 00:08'!
doItContext
	^ nil! !

!OBDefinition methodsFor: 'callbacks' stamp: 'EstebanLorenzano 7/6/2012 15:24'!
doItReceiver
	| class |
	class := self selectedClass.
	^ class ifNotNil: [ class theNonMetaClass ]
! !

!OBDefinition methodsFor: 'callbacks' stamp: 'cwp 12/26/2007 23:00'!
selectedClass
	^ nil! !

!OBDefinition methodsFor: 'callbacks' stamp: 'cwp 3/23/2004 22:16'!
selection
	^ 1 to: 0! !

!OBDefinition methodsFor: 'updating' stamp: 'cwp 6/4/2006 18:53'!
signalChange
	OBAnnouncer current announce: (OBDefinitionChanged definition: self)! !

!OBDefinition methodsFor: 'callbacks' stamp: 'cwp 3/22/2004 20:52'!
text
	^ ''! !

!OBDefinition methodsFor: 'callbacks' stamp: 'cwp 3/22/2004 20:52'!
text: aText
	^ false! !

!OBDefinition methodsFor: 'callbacks' stamp: 'cwp 3/23/2004 22:16'!
textSelection
	^ self selection! !

OBDefinition subclass: #OBMethodDefinition
	instanceVariableNames: 'theClass category source selection callback compileClass compileCategory compileText'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Alt-Browser-Standard-Definitions'!

!OBMethodDefinition commentStamp: 'cwp 1/8/2005 13:20' prior: 0!
OBMethodDefinition knows how to present method source in the browser's text pane and compile a new CompiledMethod when the source changes. It implements several safety checks to ensure that methods are not accidentally overwritten.!

!OBMethodDefinition class methodsFor: 'instance creation' stamp: 'cwp 10/17/2004 23:07'!
inCategory: aString inClass: aClass
	^ self 
		selection: nil
		source: nil
		inCategory: aString
		inClass: aClass! !

!OBMethodDefinition class methodsFor: 'instance creation' stamp: 'cwp 10/17/2004 23:07'!
selection: anInterval source: aText inCategory: aCategory inClass: aClass
	^ self new
		setClass: aClass
		category: aCategory
		source: aText
		selection: anInterval! !

!OBMethodDefinition class methodsFor: 'instance creation' stamp: 'cwp 10/17/2004 23:07'!
selection: anInterval source: aText inClass: aClass
	^ self 
		selection: anInterval
		source: aText
		inCategory: nil
		inClass: aClass	! !

!OBMethodDefinition class methodsFor: 'instance creation' stamp: 'cwp 10/17/2004 23:03'!
source: aText inClass: aClass
	^ self 
		selection: nil
		source: aText
		inCategory: nil
		inClass: aClass! !

!OBMethodDefinition methodsFor: 'callbacks' stamp: 'lr 11/25/2010 23:39'!
accept: aText notifying: aController
	| newSelector | 
	newSelector := self compileMethod: aText notifying: aController.
	newSelector ifNil: [ ^ false ]. 
	(self nodeFor: newSelector) signalCreation.
	^ true! !

!OBMethodDefinition methodsFor: 'accessing' stamp: 'cwp 10/17/2004 23:36'!
callback: aBlockContext 
	callback := aBlockContext! !

!OBMethodDefinition methodsFor: 'accessing' stamp: ''!
category
	^ category ifNil: [category := self theClass whichCategoryIncludesSelector: self selector]! !

!OBMethodDefinition methodsFor: 'accessing' stamp: 'jk 8/22/2007 20:09'!
compileCategory
	^ compileCategory! !

!OBMethodDefinition methodsFor: 'accessing' stamp: 'jk 8/22/2007 20:09'!
compileCategory: anObject
	compileCategory := anObject! !

!OBMethodDefinition methodsFor: 'accessing' stamp: 'jk 8/22/2007 18:36'!
compileClass
	^ compileClass! !

!OBMethodDefinition methodsFor: 'accessing' stamp: 'jk 8/22/2007 18:36'!
compileClass: anObject
	compileClass := anObject! !

!OBMethodDefinition methodsFor: 'compiling' stamp: 'lr 7/3/2009 21:49'!
compileMethod: aText notifying: aController 
	self compileClass: self theClass.
	self compileCategory: self category.
	self compileText: aText.
	^ self compileNotifying: aController! !

!OBMethodDefinition methodsFor: 'compiling' stamp: 'lr 3/4/2009 22:16'!
compileNotifying: aController 
	^ self compileClass 
		compile: self compileText
		classified: self compileCategory
		notifying: aController! !

!OBMethodDefinition methodsFor: 'accessing' stamp: 'jk 8/22/2007 18:37'!
compileText
	^ compileText! !

!OBMethodDefinition methodsFor: 'accessing' stamp: 'jk 8/22/2007 18:37'!
compileText: anObject
	compileText := anObject! !

!OBMethodDefinition methodsFor: 'compiling' stamp: 'cwp 10/17/2004 23:33'!
nodeFor: aSelector
	^ callback value: aSelector! !

!OBMethodDefinition methodsFor: 'callbacks' stamp: ''!
selectedClass
	^ self theClass! !

!OBMethodDefinition methodsFor: 'callbacks' stamp: 'lr 3/4/2009 08:20'!
selection
	^ selection ifNil: 
		[ 1 to: (source isNil 
				ifTrue: [ self text size ]
				ifFalse: [ 0 ]) ]! !

!OBMethodDefinition methodsFor: 'accessing' stamp: 'lr 3/4/2009 08:17'!
selector
	^ source isNil ifFalse: [ Parser new parseSelector: source ]! !

!OBMethodDefinition methodsFor: 'initializing' stamp: 'ThierryGoubier 7/16/2012 16:39'!
setClass: aClass category: aString source: aText selection: anInterval
	theClass := aClass.
	category := aString.
	source := aText.
	selection := anInterval.
	callback := [:sel | ABMethodNode on: sel inClass: theClass]! !

!OBMethodDefinition methodsFor: 'callbacks' stamp: 'lr 3/4/2009 08:18'!
text
	^ source isNil 
		ifFalse: [ source asText makeSelectorBold ]
		ifTrue: [ self theClass sourceCodeTemplate ]! !

!OBMethodDefinition methodsFor: 'accessing' stamp: ''!
theClass
	^ theClass! !

OBDefinition subclass: #OBOrganizationDefinition
	instanceVariableNames: 'organizer'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Alt-Browser-Standard-Definitions'!

!OBOrganizationDefinition commentStamp: 'cwp 1/8/2005 13:31' prior: 0!
OBOrganizationDefinition knows how to display and edit the organization of classes or methods by a Categorizer.!

!OBOrganizationDefinition class methodsFor: 'instance creation' stamp: 'cwp 9/22/2004 21:20'!
on: anOrganizer
	^ self new organizer: anOrganizer! !

!OBOrganizationDefinition methodsFor: 'accessing' stamp: 'cwp 9/22/2004 21:21'!
organizer: anOrganizer
	organizer := anOrganizer! !

!OBOrganizationDefinition methodsFor: 'callbacks' stamp: 'cwp 9/22/2004 21:18'!
text
	^ organizer asString! !

!OBOrganizationDefinition methodsFor: 'callbacks' stamp: 'lr 12/3/2010 10:24'!
text: aText
	organizer changeFromString: aText asString.
	OBAnnouncer current announce: OBRefreshRequired.
	^ true! !

MorphTreeNodeModel subclass: #ABAbstractNode
	instanceVariableNames: 'contents'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Alt-Browser'!

!ABAbstractNode commentStamp: '<historical>' prior: 0!
An ABAbstractNode is the abstract type of all nodes used by the ABPackageList.!

!ABAbstractNode methodsFor: 'accessing' stamp: 'ThierryGoubier 7/14/2012 11:19'!
browseItem
	"By default do nothing."! !

!ABAbstractNode methodsFor: 'accessing' stamp: 'ThierryGoubier 7/15/2012 23:44'!
contents
	contents isNil
		ifTrue: [ contents := super contents ].
	^ contents! !

!ABAbstractNode methodsFor: 'accessing' stamp: 'ThierryGoubier 7/14/2012 11:19'!
doubleClick
	self browseItem! !

!ABAbstractNode methodsFor: 'accessing' stamp: 'ThierryGoubier 7/14/2012 11:19'!
exploreItem
	self explore! !

!ABAbstractNode methodsFor: 'accessing' stamp: 'ThierryGoubier 7/14/2012 11:20'!
inspectItem
	self inspect! !

!ABAbstractNode methodsFor: 'accessing' stamp: 'ThierryGoubier 7/14/2012 11:20'!
keyStroke: anEvent from: aTreeMorph
	| c |
	c := anEvent keyCharacter.
	c = $b
		ifTrue: [ 
			self browseItem.
			^ true ].
	c = $i
		ifTrue: [ 
			self inspectItem.
			^ true ].
	c = $I
		ifTrue: [ 
			self exploreItem.
			^ true ].
	^ false! !

!ABAbstractNode methodsFor: 'accessing' stamp: 'ThierryGoubier 7/14/2012 11:20'!
menu: menu shifted: b 
	menu
		add: 'Expand all' translated
		target: self
		selector: #expandAll.
	menu
		add: 'Browse (b)' translated
		target: self
		selector: #browseItem.
	menu
		add: 'Inspect (i)' translated
		target: self
		selector: #inspectItem.
	menu
		add: 'Explore (I)' translated
		target: self
		selector: #exploreItem.
! !

!ABAbstractNode methodsFor: 'accessing' stamp: 'ThierryGoubier 7/16/2012 14:14'!
sourceClass
	"Should return a class if appropriate."
	
	^ nil! !

!ABAbstractNode methodsFor: 'accessing' stamp: 'ThierryGoubier 7/16/2012 14:13'!
sourceCode
	"Should return a source code if appropriate."
	
	^ ''! !

ABAbstractNode subclass: #ABClassCategoryNode
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Alt-Browser'!

!ABClassCategoryNode commentStamp: '<historical>' prior: 0!
An ABClassCategoryNode is for class categories.
!

!ABClassCategoryNode methodsFor: 'as yet unclassified' stamp: 'ThierryGoubier 7/16/2012 17:07'!
childNodeClassFromItem: anItem
	(anItem isKindOf: Class)
		ifTrue: [ ^ ABClassNode ]
		ifFalse: [ ^ self class ]! !

!ABClassCategoryNode methodsFor: 'as yet unclassified' stamp: 'ThierryGoubier 7/17/2012 13:08'!
childrenItems
	"Extract from the organisation the various classes. Ok. Our upper level should try to built a hierarchy with the category name, if applicable (via various upTo: $-). This code is ready for that (introduce an additional hierarchy)."

	| c o |
	c := Smalltalk organization categoriesMatching: self item.
	c size > 2
		ifTrue: [ ^ c ]
		ifFalse: [ 
			o := OrderedCollection new.
			c do: [ :e | (Smalltalk organization classesInCategory: e) do: [ :class | o add: class ] ].
			^ o ]! !

ABAbstractNode subclass: #ABClassCommentNode
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Alt-Browser'!

!ABClassCommentNode commentStamp: '<historical>' prior: 0!
An ABClassCommentNode is for a class comment, if any. No children.
!

!ABClassCommentNode methodsFor: 'as yet unclassified' stamp: 'ThierryGoubier 7/17/2012 10:34'!
asString
	^ 'comment' asText addAttribute: TextEmphasis italic! !

!ABClassCommentNode methodsFor: 'as yet unclassified' stamp: 'ThierryGoubier 7/16/2012 20:36'!
sourceCode
	^ self item comment! !

ABAbstractNode subclass: #ABClassNode
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Alt-Browser'!

!ABClassNode commentStamp: '<historical>' prior: 0!
An ABClassNode represent a class!

ABClassNode subclass: #ABClassExtensionNode
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Alt-Browser'!

!ABClassExtensionNode commentStamp: '<historical>' prior: 0!
An ABClassExtensionNode is used when browsing the extension of a package. Restrict itself to the methods of the extension of the parent package.!

!ABClassExtensionNode methodsFor: 'as yet unclassified' stamp: 'ThierryGoubier 7/17/2012 13:37'!
asString
	^ self item asString! !

!ABClassExtensionNode methodsFor: 'as yet unclassified' stamp: 'ThierryGoubier 7/17/2012 13:39'!
childNodeClassFromItem: anItem
	^ ABMethodNode! !

!ABClassExtensionNode methodsFor: 'as yet unclassified' stamp: 'ThierryGoubier 7/17/2012 13:52'!
childrenItems
	^ (self parentNode item packageInfo extensionMethodsForClass: self item) collect: [ :e | e selector ]! !

!ABClassNode methodsFor: 'as yet unclassified' stamp: 'ThierryGoubier 7/17/2012 10:33'!
asString
	^ self item isMeta
		ifTrue: [ '- Class' ]
		ifFalse: [ self item asString ]! !

!ABClassNode methodsFor: 'as yet unclassified' stamp: 'ThierryGoubier 7/16/2012 20:07'!
childNodeClassFromItem: anItem
	anItem == self item classSide
		ifTrue: [ ^ self class ].
	anItem == self item
		ifTrue: [ ^ ABClassCommentNode ].
	^ ABMethodCategoryNode! !

!ABClassNode methodsFor: 'as yet unclassified' stamp: 'ThierryGoubier 7/16/2012 20:06'!
childrenItems
	^ self item isMeta
		ifFalse: [ 
			{(self item classSide).
			(self item)} , self item organization categories ]
		ifTrue: [ self item organization categories ]! !

!ABClassNode methodsFor: 'as yet unclassified' stamp: 'ThierryGoubier 7/16/2012 13:56'!
classSide
	^ self item isMeta
		ifFalse: [ {(self item classSide)} ]
		ifTrue: [ {} ]! !

!ABClassNode methodsFor: 'as yet unclassified' stamp: 'ThierryGoubier 7/17/2012 13:54'!
privateClass
	^ self item! !

!ABClassNode methodsFor: 'as yet unclassified' stamp: 'ThierryGoubier 7/16/2012 14:18'!
sourceCode
	^ self item definition! !

ABAbstractNode subclass: #ABMethodCategoryNode
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Alt-Browser'!

!ABMethodCategoryNode commentStamp: '<historical>' prior: 0!
For a method category. No need for an -- all ---, the tree list allow for opening everything if needed. The 'as yet unclassified' method category (protocol) is managed on the fly (and exist in the system) !

!ABMethodCategoryNode methodsFor: 'as yet unclassified' stamp: 'ThierryGoubier 7/16/2012 00:18'!
childNodeClassFromItem: anItem
	^ ABMethodNode! !

!ABMethodCategoryNode methodsFor: 'as yet unclassified' stamp: 'ThierryGoubier 7/16/2012 00:03'!
childrenItems
	^ self parentNode item methodsInCategory: self item! !

!ABMethodCategoryNode methodsFor: 'as yet unclassified' stamp: 'ThierryGoubier 7/17/2012 13:54'!
privateClass
	^ self parentNode privateClass! !

!ABMethodCategoryNode methodsFor: 'as yet unclassified' stamp: 'ThierryGoubier 7/17/2012 13:53'!
sourceClass
	^ self parentNode item! !

ABAbstractNode subclass: #ABMethodNode
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Alt-Browser'!

!ABMethodNode commentStamp: '<historical>' prior: 0!
Represent a method. Should be used to get the method source, selector and whatever.!

!ABMethodNode methodsFor: 'as yet unclassified' stamp: 'ThierryGoubier 7/17/2012 13:55'!
sourceClass
	"Get the class through the parent."

	^ (self parentNode privateClass compiledMethodAt: self item) methodClass! !

!ABMethodNode methodsFor: 'as yet unclassified' stamp: 'ThierryGoubier 7/17/2012 13:55'!
sourceCode
	"Get the source code through the parent."

	^ (self parentNode privateClass compiledMethodAt: self item) sourceCode! !

ABAbstractNode subclass: #ABPackageCategoryNode
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Alt-Browser'!

!ABPackageCategoryNode commentStamp: '<historical>' prior: 0!
An ABPackageCategoryNode represent a category of packages.

item contains an association "package category name" -> "list of packages.".

!

!ABPackageCategoryNode methodsFor: 'as yet unclassified' stamp: 'ThierryGoubier 7/14/2012 23:17'!
asString
	^ item key! !

!ABPackageCategoryNode methodsFor: 'as yet unclassified' stamp: 'ThierryGoubier 7/15/2012 13:58'!
childNodeClassFromItem: anItem
	^ ABPackageNode! !

!ABPackageCategoryNode methodsFor: 'as yet unclassified' stamp: 'ThierryGoubier 7/14/2012 23:18'!
childrenItems
	^ item value! !

ABAbstractNode subclass: #ABPackageNode
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Alt-Browser'!

!ABPackageNode commentStamp: '<historical>' prior: 0!
An ABPackageNode represent a package and all classes matching it (categories).
!

ABPackageNode subclass: #ABPackageExtensionNode
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Alt-Browser'!

!ABPackageExtensionNode commentStamp: '<historical>' prior: 0!
An ABPackageExtensionNode is for the extensions part of a package.!

!ABPackageExtensionNode methodsFor: 'as yet unclassified' stamp: 'ThierryGoubier 7/17/2012 13:31'!
asString
	^ '*extensions*'! !

!ABPackageExtensionNode methodsFor: 'as yet unclassified' stamp: 'ThierryGoubier 7/17/2012 13:38'!
childNodeClassFromItem: anItem
	^ ABClassExtensionNode! !

!ABPackageExtensionNode methodsFor: 'as yet unclassified' stamp: 'ThierryGoubier 7/17/2012 13:28'!
childrenItems
	^ self item packageInfo extensionClasses! !

!ABPackageNode methodsFor: 'as yet unclassified' stamp: 'ThierryGoubier 7/15/2012 07:49'!
asString
	^ self item packageName! !

!ABPackageNode methodsFor: 'as yet unclassified' stamp: 'ThierryGoubier 7/17/2012 13:30'!
childNodeClassFromItem: anItem
	((anItem isKindOf: Class) or: [ anItem isKindOf: Metaclass ])
		ifTrue: [ ^ ABClassNode ].
	(anItem isKindOf: MCWorkingCopy)
		ifTrue: [ ^ ABPackageExtensionNode ].
	^ ABClassCategoryNode! !

!ABPackageNode methodsFor: 'as yet unclassified' stamp: 'ThierryGoubier 7/17/2012 13:23'!
childrenItems
	"Extract from the organisation the various classes."

	| c o |
	c := self item packageInfo systemCategories.
	o := OrderedCollection new.
	o add: self item.
	c size = 1
		ifTrue: [ c do: [ :e | (Smalltalk organization classesInCategory: e) do: [ :class | o add: class ] ] ]
		ifFalse: [ o addAll: (c" reject: [ :e | Smalltalk organization isEmptyCategoryNamed: e ]") ].
	^ o! !
ORCmdEnvironment initialize!
OBCmdAutoCategorize initialize!
